if(!dojo._hasResource["com.ibm.mm.builder.dialog.EmbeddingWidgetDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.EmbeddingWidgetDialog"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");
dojo.require("dojo.cookie");

/**
 * This class will launch a custom dialog to show the embed widget UI.
 */
dojo.declare("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog",null,{
	/**
	 * the root element id which the embed widget UI will be appended.
	 * @type String
	 */
	rootId:null,
	/**
	 * embed widget ID.
	 * @type String
	 */
	widgetId:null,
	
	/**
	 * widget instance ID for the widget to be embedded.
	 * @type String
	 */		
	widgetInstanceId:null,
	
	/**
	 * id of the div to host embedding dlg 
	 * @type String
	 */		
	embeddingDlg_ID:"mainEmbeddingDialog",

	/**
	 * id of the div to host embedding preview dlg 
	 * @type String
	 */	
	embeddingPreviewDlg_ID:"mainEmbeddingPreviewDialog",
	
	/**
	 * widget edit mode dlg
	 * @type Object
	 */
	editPane:null,
	
	/**
	 * open the preview by default or not
	 * @type String
	 */
	openPreviewAuto: "auto", // open preview by default
	
	openPreviewForce: "force", // user click the preview button
	
	dojoConnectors:[], 
	
	/**
	 * Constructor
	 * set open preview as true by default, subscribe a close dlg topic
	 */	
	constructor: function(_rootId, _widgetId){
		this.widgetId = _widgetId;
		this.rootId = _rootId;
		var preview = dojo.cookie("open_embed_widget_preview") || true;
		this.openEmbedWidgetPreview = (preview == "true") ? true : false;
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog");
	},

	/**
	 * create the embedding widget dlg UI content
	 * @param {Object} stub
	 */	
	createEmbedingContent:function(widgetDef,status){
		var modes = widgetDef.getSupportedModes();
		var enableEditSetting = true;
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetInstanceId);
		
		var desc = "";
		// check the widget supported mode
		if (modes!==null && modes.length >0) {	
			if (!this._belong("edit",modes)){
				enableEditSetting = false;
				desc = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_WIDGET_DESC_NOEDITMODE;
			}else{
				desc = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_WIDGET_DESC_WITHEDITMODE;
			}
		}else{
			this.LOGGER.severe("createEmbedingContent",com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_WIDGET_ERROR_0);
		}			
		
		//update the description
		if (desc !== "") {
			dojo.byId("_" + this.widgetId + "_embed_desc").innerHTML = desc;
		}
		
		var inDialog = this.dialogContainer===null?false:true;
		
		// create the preview dlg
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PAGE_PREVIEW_TITLE, [widgetTitle]);
		if (!this.previewDlg){
			this.previewDlg = new com.ibm.mm.builder.widget.CustomDialog({
				id:	this.embeddingPreviewDlg_ID,
				containerBackgroundColor: "white",
				nodeWidth:dojo.isIE?"520px":'515px',
				nodeHeight:dojo.isIE?(dojo.isIE==6?"505px":"512px"):"516px",
				initLeftPosition: "700px",
				initTopPosition: "100px",
				modelDialog:!inDialog,
				needUnderLay: false,
				scrollEnabled: true
				// 8143/9205: if bidi, CustomDialog will not add the 'custom_dialog_nomodel'
				// class which interferes with the left/right movement of the dialog
				// 9637: removed rtl version of custom_dialog_nomodel so removed param isEmbedPageBidi
			});			
		}
		this.previewDlg.setTitle(title);
		
		if (inDialog) {
			this.dialogContainer.registerSubDialog(this.embeddingPreviewDlg_ID);
		}
		
		this.previewEmbedding(this.openPreviewAuto);
		this.updateMarkup();
		// bind event
		this.dojoConnectors.push(dojo.connect(document.getElementsByName("_"+this.widgetId + "_emdPgWidth")[0], "onclick", this, function(){
			dojo.byId("_"+this.widgetId + "_width").disabled = false;
		}));
		this.dojoConnectors.push(dojo.connect(document.getElementsByName("_"+this.widgetId + "_emdPgWidth")[1], "onclick", this, function(){
			dojo.byId("_"+this.widgetId + "_width").disabled = true;
		}));
		this.dojoConnectors.push(dojo.connect(dojo.byId("_"+this.widgetId +"_close"), "onclick", this, "hideEmbeddingDlg"));
		this.dojoConnectors.push(dojo.connect(dojo.byId("_"+this.widgetId +"_preview"), "onclick", this, "previewEmbeddingAction"));	
		this.dojoConnectors.push(dojo.connect(dojo.byId("_"+this.widgetId +"_updateLink"), "onclick", this, "updateMarkup"));
		var embedEditButton = dojo.byId("_"+this.widgetId +"_embedEdit");
		if (enableEditSetting){
			this.dojoConnectors.push(dojo.connect(embedEditButton, "onclick", this, "loadEditMode"));
		}else{
			embedEditButton.disabled = true;
			dojo.toggleClass(embedEditButton, "lotusFormButton", false);
			dojo.toggleClass(embedEditButton, "lotusFormButtonDisabled", true);
		}		
	},

	/**
	 * show the embedding widget dlg
	 */		
	updateEmbedding: function(){
		var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.widgetInstanceId);
		var getSMDeferred = widgetWrapper.getIWidgetDefinition();
		getSMDeferred.setFinishedCallback(dojo.hitch(this, this.createEmbedingContent));
		getSMDeferred.start(false);
	},
	
	destroyEmbeddedWidget: function(){
		com.ibm.mm.builder.utils.embedUtil.destroyEmbeddedWidget(this.widgetInstanceId);
		for (var i=0;i<this.dojoConnectors.length;i++){
			dojo.disconnect(this.dojoConnectors[i]);
		}
		this.dojoConnectors=[];
	},
	
	/**
	 * hide the embedding widget dlg
	 */		
	hideEmbeddingDlg: function(){
	    this.destroyEmbeddedWidget();
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.widgetId);
	},

	/**
	 * preview action when user click the Preview button in embedding widget UI
	 */	
	previewEmbeddingAction:function(){
		this.previewEmbedding(this.openPreviewForce);
	},

	/**
	 * show the preview dlg
	 * @param {String} previewType indicate whether the preview action is from user clicking the Preview button, or from auto preview
	 */	
	previewEmbedding: function(previewType){
		if (previewType == this.openPreviewAuto){
			if (!this.openEmbedWidgetPreview){
				// user have change the default open preview to false
				return;
			}
		}
		var validInput = com.ibm.mm.builder.utils.embedUtil.validateInput("_"+this.widgetId,this.embeddingDlg_ID);
		if (!validInput) {
			return null;
		}		
		if (this.previewDlg){
			this.previewDlg.dynaInitialized = false;
			this.previewDlg.show();	
			var root = this.previewDlg.containerNode;
			// create the preview UI
			root.innerHTML = "";
			root.appendChild(com.ibm.mm.builder.utils.embedUtil.createCheckPreview(this.widgetInstanceId,this.openEmbedWidgetPreview));
			root.appendChild(com.ibm.mm.builder.utils.embedUtil.createClearDiv());
			var iframeUID = com.ibm.mm.builder.utils.iwidgetUtil._getUid();
			var aframe = document.createElement("iframe");
			aframe.id = iframeUID;
			aframe.name = iframeUID;
			aframe.title = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PREVIEW_FRAME;
			
			var widthValue = com.ibm.mm.builder.utils.embedUtil.getWidth("_"+this.widgetId);
			if (widthValue == "auto"){
				aframe.style.width = "100%";
			} else {
				aframe.style.width = widthValue;
			} 
			// add the height of " Widget powered by IBM Lotus Mashups"
			aframe.style.height = parseInt(com.ibm.mm.builder.utils.embedUtil.getHeight("_"+this.widgetId),10) + 25 + "px";
			aframe.scrolling = "no";
			aframe.frameBorder = 0;
			aframe.marginWidth = 0;
			aframe.frameSpacing = 0;
			aframe.marginHeight = 0;
			root.appendChild(aframe);	
			dojo.byId(this.widgetInstanceId +"_checkBox").setAttribute("accesskey", "A");
			dojo.byId(this.widgetInstanceId +"_closeLink").setAttribute("accesskey", "C");
			dojo.connect(dojo.byId(this.widgetInstanceId +"_checkBox"), "onclick", this, "reverseDefaultPreview");
			dojo.connect(dojo.byId(this.widgetInstanceId +"_closeLink"), "onclick", this, "hidePreview");			
			var iframeDoc = window.frames[iframeUID].document;
			iframeDoc.open();
			var url = this.generateURL();
			if (url){
				iframeDoc.write("<html><body><scr"+"ipt src=\"" + url + "\"></scr"+"ipt></body></html>");
			}	
			if (!dojo.isIE){
				iframeDoc.close();
			}
			this.updateMarkup();					
		}else{
			this.LOGGER.severe("previewEmbedding",com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_NOPREVIEWDLG_ERROR_0);
		}			
	},

	/**
	 * call enabler embedding generator to get the embeddable url
	 */
    generateURL:function() {
		var validInput = com.ibm.mm.builder.utils.embedUtil.validateInput("_"+this.widgetId,this.embeddingDlg_ID);
		var widgetXmlUrl;
		if (!validInput) {
			return null;
		}
		try {
			widgetXmlUrl = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetXMLURL(this.widgetInstanceId);
		}
		catch(e){
			return null;
		}
		
		// call iWidgetInstance from enabler to get all the itemset
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var iWidgetInstance = widgetModel.find(this.widgetInstanceId).getIWidgetInstance();

        if (iWidgetInstance === null) {
            this.LOGGER.severe(
            	"generateURL",
            	dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_NOWIDGET_ERROR_1,[this.widgetInstanceId])
            );
			return null;
        }
        var instanceAttributes = iWidgetInstance.getAttributes();			
		
		var width ="auto";
		if(dojo.query("[name=" + "_"+this.widgetId + "_emdPgWidth]")[0].checked){
			width = dojo.byId("_"+this.widgetId+"_width").value;
		}
		
		var height = dojo.byId("_"+this.widgetId+"_height").value;
		
		var haveScroll = false;
		if(dojo.query("[name=" + "_"+this.widgetId + "_emdPgScroll]")[0].checked){
			haveScroll = true;
		}

        var sandboxed = false;
        
        var widgetSpan = dojo.byId(this.widgetInstanceId);
        if (widgetSpan && widgetSpan.getAttribute("sandbox") === "true") {
            sandboxed = true;
        }

		return com.ibm.mm.builder.utils.embedUtil.generateURL(widgetXmlUrl,null,width,height,haveScroll,instanceAttributes,sandboxed);
    },

	/**
	 * action method when user click "Update Markup" in embedding UI.
	 * It will update the markup in the textarea 
	 */
	updateMarkup:function(){
		var url = this.generateURL();
		if (url){
			var markup = "<scr"+"ipt src=\"" + url + "\"></scr"+"ipt>";
			var textArea = dojo.byId("_"+this.widgetId+"_markup");
			var w = dojo.coords(textArea).w; 	
			textArea.style.width = w;	
			textArea.value = markup;	
			textArea.style.width = "98%";			
		}
	},

	/**
	 * load the widget edit mode dlg
	 */			
    loadEditMode: function(){
        var _title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetInstanceId);
	    this.editPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
            id: this.widgetInstanceId + "_edit",
            title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_SYSTEM_CONF_TITLE, [_title]),
            type: "config",
            nodeWidth: dojo.byId(this.widgetInstanceId).getAttribute("sandbox") === "true" ? "600px" : null,
			nodeHeight: dojo.byId(this.widgetInstanceId).getAttribute("sandbox") === "true" ? "400px" : null,
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            needModeSwitch: true,
            belongId: this.widgetInstanceId,
            containerBackgroundColor: "white",
			closeCallback: function(){
				this.destroy(); 
			}
        });
		this.dojoConnectors.push(dojo.connect(this.editPane,"closeCallback",this,this.updateMarkup));
        com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.widgetInstanceId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: this.editPane.containerNode
        });
        this.editPane.show();
    },
	
	/**
	 * destroy the edit mode dlg
	 */	
	destroyEditPane: function(){
		if(dijit.byId(this.widgetInstanceId + "_edit")){
			dijit.byId(this.widgetInstanceId + "_edit").destroy();	
		}
	},

	/**
	 * hide the preview dlg
	 */	
	hidePreview:function(){
		if (this.previewDlg){
			this.previewDlg.hide();
		}
	},

	/**
	 * action method when check the checkbox "show preview by default"
	 */	
	reverseDefaultPreview:function(){
		this.openEmbedWidgetPreview = !this.openEmbedWidgetPreview;
		dojo.cookie("open_embed_widget_preview",this.openEmbedWidgetPreview);
	},		

	_belong:function(value, arr){
		for (var i in arr) {
			if (arr[i] == value) {
				return true;
			}
		}
	}			
	
});

}
