if(!dojo._hasResource["com.ibm.mm.builder.iwidget.GenericLayout"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.GenericLayout"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.GenericLayout");

/**
 * Summary: Define common action in layout widget.
 */
dojo.declare("com.ibm.mm.builder.iwidget.GenericLayout", null, {
	
	layoutWidgetId: "",
	
	widgetContainerId:"",

	//Layout widget common behavior
	getWidgetInstanceId:function(){
		return this.layoutWidgetId;
	},
	
	getWidgetDefURL:function(){
		var iwidgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		return iwidgetUtil.getWidgetXMLURL(this.layoutWidgetId);
	},
	
	//Layout widget common ievent handler
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.changePageMode'
	 * @param {Object} iEvent payload
	 */
	onPageModeChanged: function(iEvent){
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.pageSwitched'
	 * @param {Object} iEvent payload
	 */
    onPageSwitched: function(iEvent){
    },
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.addWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetAdded:function(iEvent){
	},		

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetResized:function(iEvent){
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.stateChanged'
	 * @param {Object} iEvent payload
	 */	
	onStateChanged:function(iEvent){
	},	
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.moveAction'
	 * @param {Object} iEvent payload
	 */
    onMoveDialogShow: function(iEvent){
    },	
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeAction'
	 * @param {Object} iEvent payload
	 */	
    onResizeDialogShow: function(iEvent){
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.displayWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetDisplayed: function(iEvent){
	},				
		
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.highlightWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetHighlighted:function(iEvent){
		var widgetId = iEvent.payload;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.widgetContainerId)){
			// highlight the widget
		    var skin = dojo.byId(widgetId).getAttribute("skin");
		    var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		    
		    var coords = dojo.coords(skinDiv);
		    var scroll = dojo._docScroll();
		    var highlightDiv = dojo.byId("mmDiv_highlight");
		    if (!highlightDiv) {
		        highlightDiv = document.createElement("div");
		        highlightDiv.id = "mmDiv_highlight";
		        highlightDiv.style.position = "absolute";
		        highlightDiv.style.backgroundImage = "url('" + builderConfig.builderPath + "/images/widget_highligh_color.png')";
		        document.body.appendChild(highlightDiv);
		    }
		    highlightDiv.style.display = "none";
		    highlightDiv.style.left = (coords.x + scroll.x) + "px";
		    highlightDiv.style.top = (coords.y + scroll.y) + "px";
	        highlightDiv.style.width = coords.w + "px";
	        highlightDiv.style.height = coords.h + "px";
	        // zIndex must smaller than wiring pane
	        highlightDiv.style.zIndex = 780;
		    highlightDiv.style.display = "";			
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.removeWidgetHighlight'
	 * @param {Object} iEvent payload
	 */
	onWidgetHighlightRemoved:function(iEvent){
		var highlightDiv = dojo.byId("mmDiv_highlight");
	    if (highlightDiv){
	    	highlightDiv.style.display = "none";
	    }
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.renameWidget'
	 * @param {Object} iEvent payload
	 */	
	onWidgetRenamed:function(iEvent){
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.id;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.widgetContainerId)){
			com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitle(widgetId,widgetInfo.name, widgetInfo.locale);
			com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(widgetId);				
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.addNewWire'
	 * @param {Object} iEvent payload
	 */
	onNewWireAdded:function(iEvent){
		var wireInfo = iEvent.payload;
		var targetWidgetId = wireInfo.targetWidgetId;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(targetWidgetId,this.widgetContainerId)){
			com.ibm.mm.builder.utils.wireUtil.addWire(wireInfo.sourceWidgetId, wireInfo.sourceEvent, wireInfo.targetWidgetId, wireInfo.targetEvent);
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.removeWire'
	 * @param {Object} iEvent payload
	 */
	onWireRemoved:function(iEvent){
		var wireInfo = iEvent.payload;
		var targetWidgetId = wireInfo.targetWidgetId;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(targetWidgetId,this.widgetContainerId)){
			com.ibm.mm.builder.utils.wireUtil.removeWire(wireInfo.sourceWidgetId, wireInfo.sourceEvent, wireInfo.targetWidgetId, wireInfo.targetEvent);
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.changeSkin'
	 * @param {Object} iEvent payload
	 */
	onWidgetSkinChanged: function(iEvent){
		var para = iEvent.payload;
		var widgetId = para.id;
		var newskin = para.skin;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.widgetContainerId)){
			this.processLocationWhenChangeSkin(widgetId);
			var widgetSpan = dojo.byId(widgetId);
			var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
			if(dojo.isIE || dojo.isSafari){
				var widgetBody = dojo.query(".widgetBody", widgetSkin)[0];
				if (widgetBody) {
					widgetBody.onselectstart = null;
				}
			}
			widgetSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, newskin);
			dojo.publish("/com/ibm/mashups/livetext/livetextchanged", [widgetSpan]);
		}		
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.skinLoaded'
	 * @param {Object} iEvent payload
	 */
	onSkinLoaded: function(iEvent){
		var message = iEvent.payload;
		var widgetId = message.widgetId;
		if (!com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId, this.widgetContainerId)) {
			return;
		}
		this.postAttachSkin(message);
	},
	
	//skin behavior
	processLocationWhenChangeSkin:function(widgetId){
	},
	
	postAttachSkin:function(message){
	}
});

}
