if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.string");

/**
 * ThemesListControl
 */
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl", [dijit._Widget, dijit._Templated], {

    widgetId: null,
    
    selectedTheme: null,
    
    templateString: "<div tabindex='0' role='listbox' aria-required='true' dojoAttachEvent='onclick:selectThemeByMouse' class='themesListControl'><div dojoAttachPoint='themesList'></div></div>",
    
    connections: [],
    /**
     * Constructor.
     */
    constructor: function(){
        this.resourceBundle = com.ibm.mm.builder.coreWidgetsStrings;
    },
    
    freeThemesList: function(){
        if (this.themesList) {
            dojo.forEach(this._connects, function(array){
                dojo.forEach(array, dojo.disconnect);
            });
            var childs = this.themesList.childNodes;
            for (var i = childs.length - 1; i >= 0; i--) {
                var item = childs[i];
                this.themesList.removeChild(item);
                delete item;
            }
        }
    },
    
    refresh: function(themeId){
        this._themeIdPrefix = this.widgetId + "_theme_list_";
        
        this.freeThemesList();
        this.themesList.innerHTML = "";
        
        var themeUtil = com.ibm.mm.builder.utils.themeUtil;
        var themeModel = themeUtil.getThemeModel();
        var defaultNode = themeUtil.getDefaultThemeNode();
        var defaultNodeId = defaultNode.getID();
        
        //load all existing themes, put the default at the top
        var iterator = themeModel.iterator();
        while (iterator.hasNext()) {
        
            var themeNode = iterator.next();
            var themeNodeId = themeNode.getID();
            
            var themeDiv = dojo.doc.createElement("div");
            dojo.attr(themeDiv, "id", this._themeIdPrefix + themeNodeId);
            dojo.attr(themeDiv, "tabindex", "0");
            
            var alt = themeUtil.getThemeTitle(themeNode, builderConfig.locale);
            
            /* some a11y */
            dojo.attr(themeDiv, "title", alt);
            dojo.attr(themeDiv, "aria-label", alt);
            dojo.attr(themeDiv, "role", "option");
            
            this.connect(themeDiv, "onkeypress", "selectThemeByKey")
            this.connect(themeDiv, "onclick", "selectThemeByMouse")
            
            dojo.addClass(themeDiv, "space_theme_unselected");
            
            var imgNode = dojo.doc.createElement("img");
            
            var previewImgName = themeNode.getMetaData("preview-url");
            if (!previewImgName || previewImgName.length === 0) {
                previewImgName = "preview.png";
            }
            
            dojo.attr(imgNode, "src", com.ibm.mm.builder.utils.themeUtil.getThemeModel().findResourceUrl(themeNode, previewImgName));
            dojo.attr(imgNode, "alt", alt);
            
            themeDiv.appendChild(imgNode);
            
            var titleNode = dojo.doc.createElement("div");
            titleNode.innerHTML = alt;
            themeDiv.appendChild(titleNode);
            dojo.addClass(titleNode, "theme_title");
            
            if ((0 < this.themesList.childNodes.length) && (defaultNodeId == themeNodeId)) {
                this.themesList.insertBefore(themeDiv, this.themesList.firstChild);
            }
            else {
                this.themesList.appendChild(themeDiv);
            }
        }
        
        if (themeId) {
            this.setSelectedTheme(themeId);
        }
        else {
            // Select the default theme
            this.setSelectedTheme(defaultNodeId);
        }
    },
    
    _themeIdDecode: function(themeId){
        //var indexS = themeId.lastIndexOf('_');
        //return(themeId.substring(indexS + 1));
        return themeId.substring(this._themeIdPrefix.length);
    },
    
    setSelectedTheme: function(themeId){
        this.selectedTheme = themeId;
        this.highlightSelectedTheme(themeId);
    },
    
    highlightSelectedTheme: function(themeId){
        var themeDiv = dojo.byId(this._themeIdPrefix + themeId);
        if (themeDiv) {
            var themes = themeDiv.parentNode.childNodes;
            
            for (var i = 0; i < themes.length; i++) {
                if (themes[i].className.indexOf("space_theme") > -1) {
                    if (themes[i].id == themeDiv.id) {
                        dojo.removeClass(themes[i], "space_theme_unselected");
                        dojo.addClass(themes[i], "space_theme_selected");
                        
                        var isSelected = dojo.doc.createElement("span");
                        dojo.addClass(isSelected, "access");
                        isSelected.appendChild(dojo.doc.createTextNode(this.resourceBundle.I_MODE_IS_SELECT));
                        themes[i].appendChild(isSelected);
                    }
                    else {
                        dojo.removeClass(themes[i], "space_theme_selected");
                        dojo.addClass(themes[i], "space_theme_unselected");
                        var items = dojo.query(".access", themes[i]);
                        dojo.forEach(items, function(item){
                            themes[i].removeChild(item);
                        });
                    }
                }
            }
        }
    },
    
    selectThemeByKey: function(evt){
        if (evt.keyCode != dojo.keys.ENTER && evt.charCode != dojo.keys.SPACE) {
            return;
        }
        var themeDiv = evt.target;
        
        this.setSelectedTheme(this._themeIdDecode(themeDiv.id));
    },
    
    selectThemeByMouse: function(evt){
        var clicked = evt.target;
        
        var themeDiv = null;
        if (clicked.tagName != "IMG") {
            return;
        }
        
        themeDiv = clicked.parentNode;
        
        this.setSelectedTheme(this._themeIdDecode(themeDiv.id));
    },
    
    destroy: function(){
        this.freeThemesList();
        
        if (this.themesList) {
            delete this.themesList;
        }
    }
});

}
