if(!dojo._hasResource["com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.TooltipDialog");

dojo.require("com.ibm.mm.builder.dnd.MashupSource");
dojo.require("com.ibm.mm.builder.widget.ExtendableShadowMenu");
dojo.require("com.ibm.mm.builder.iwidget.navigation.NavigationPanel");

/**
 * This dijit will render the whole toolbox pane including toolbox drawer and menu.
 * todo refactor with menubar in next version.
 * @version 2.0
 */
(function(){
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var toolboxUtil = utils.toolboxUtil;
var iwidgetUtil = utils.iwidgetUtil;
var spaceUtil = utils.spaceUtil;
var themeUtil = utils.themeUtil;
var enablerUtil = utils.enablerUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cwm = com.ibm.mm.builder.coreWidgetsMessages;
var cws = com.ibm.mm.builder.coreWidgetsStrings;

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel",
	[dijit._Widget, dijit._Templated, dijit._Container], {
	
	templateString: '<div class="toolboxPanel"><ul dojoAttachPoint="containerNode"></ul></div>',
	
	/**
	 * Hide the palette
	 */
	hide: function() {
		dojo.fx.wipeOut({node:this.domNode, duration:500}).play();
		this.domNode.style.display = "none";
	},
	/**
	 * Show the palette
	 */
	show: function() {
		if(this.getChildren().length === 0){ this.refresh(); }
		
		dojo.fx.wipeIn({
			node: this.domNode,
			duration: 500,
			onEnd: (dojo.isIE === 6) ? dojo.hitch(this, function(){this.domNode.style.display = "block";}) : null
		}).play();
		 
		if (dojo.isIE === 7) { this.domNode.style.display = "block"; }
	},
	
	/**
	 * render toolbox and assign its item context
	 */
	refresh: function(){
		//destroy all children
		dojo.forEach(this.getChildren(), function(c){
			if (c.destroy) {c.destroy();}
		});
		
		var cs = toolboxUtil.getCategories();
		for(var i=0; i<cs.length && i< 5; i++){
			var entry = new com.ibm.mm.builder.iwidget.toolbox.ToolboxPanelItem({categoryNode: cs[i]});
			this.addChild(entry);
		}
	}
});

/**
 * This dijit will render the drawer including toolbox pop menu
 */
dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxPanelItem", 
	[dijit._Widget, dijit._Templated, dijit._Container], {

	categoryNode: null,
	
	templateString: 
		'<li dojoAttachEvent="onmouseover:_onHover, onmouseout:_onUnHover, onkeypress:_onKeyPress">' +
			'<div dojoAttachPoint="containerNode" class="toolboxPanelItem" tabindex=0 role="button">' +
				'<span dojoAttachPoint="categoryTitle" class="toolboxPanelItemTitle" > </span>' +
				'<img dojoAttachPoint="toolboxPanelItemIcon" class="toolboxPanelItemIcon" alt=""></img>' +
			'</div>' +
		'</li>',
	
    postCreate: function(){
		var title = enablerUtil.getNodeTitle(this.categoryNode);
		var node = this.categoryTitle;
		setTimeout(function(){ //set timeout to wait for the css is applied
			node.innerHTML = htmlUtil.getStrWithLimit(title, node, 132);
			node.title = title;
		}, 0);
		this.toolboxPanelItemIcon.src = builderConfig.builderPath + "/images/toolbox/drawerClosedTriangle.gif";
	},
	
	onFocus:function(){
		this._onHover();
	},
	
	onBlur:function(){
		this._onUnHover();
	},
	
	_onKeyPress: function(e){
		switch (e.keyCode) {
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
				if (this.itemMenu) {
					this.itemMenu._openMyself(e);
				}
				break;
		}
	},
	
    _onHover: function(e){
		dojo.addClass(this.containerNode, "toolboxPanelItemHover");
		this.itemMenu = this.itemMenu || new com.ibm.mm.builder.iwidget.toolbox.ToolboxMenu({
			targetNodeIds:[this.containerNode],
			catagory:this.categoryNode
		});
    },
    
    _onUnHover: function(e){
		if(this.itemMenu && !this.itemMenu.isShowingNow) {
			dojo.removeClass(this.containerNode, "toolboxPanelItemHover");
		}
    },
	
	destroy: function(){
		if(this.itemMenu){
			this.itemMenu.destroyDescendants();
			this.itemMenu.destroy();
		}
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxMenu",
	com.ibm.mm.builder.widget.ExtendableShadowMenu,
{	
	catagory: null,
	offset_x: -1,
	offset_y: 1,
	
	//store tooltip timer
	toolTipTimers: [],
	
	postCreate: function(){
		this.limitedSize = com.ibm.mm.builder.constant.ToolboxPageSize;
        this.inherited(arguments);
        dojo.addClass(this.domNode, "toolboxMenu");
		dojo.subscribe("/dnd/start", this, function(){ dijit.popup.close(this); });
	},
	
	onItemHover: function(item){
		this.focusChild(item);
	},
	
	prepareData: function(){
		
		var _catModel = toolboxUtil.getCatalogModel();
		var _categoryModel = _catModel.getCatalogEntryModel(this.catagory);
		var elemIterator = _categoryModel.iterator();
		elemIterator.setCursorPosition(0);
		while (elemIterator.hasNext()) {
			if (this.loadedEntriesNumber >= com.ibm.mm.builder.constant.ToolboxPageSize) {
				this.hasMorePage = true;
				this.isLastItemShowed = false;
				break;
			}
			var entry = elemIterator.next();
			//cache the widget defs
			toolboxUtil.setWidgetDefinition(entry);
			
			this.addChild(this.createNewItem(entry));
			this.loadedEntriesNumber++;
			this.dndsource = new com.ibm.mm.builder.dnd.MashupAutoSource(this.domNode, {
				singular: true,
				accept: ["none"],
				creator: function(item, hint){
					if (hint == "avatar") {
						return {
							node: new com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuItemAvatar({
								widgetDefId: item
							}).domNode,
							data: item,
							type: ["iWidgetDefinition"]
						};
					}
				}
			}); //JSLINT-IGNORE: follow dojo dnd rule
			this.pages = elemIterator;
		}
		if(this.loadedEntriesNumber === 0 && com.ibm.mm.builder.commonActions.hasHub()){
			this.emptyCatalog = this.emptyCatalog ||
			new com.ibm.mm.builder.iwidget.toolbox.EmptyCatalogMessageBox({
				label: dojo.string.substitute(cws.I_TOOLBOX_NO_CHILD_IN_CATEGORY, 
					["<a href='#' onclick='com.ibm.mm.builder.commonActions.catalogNewWindow(); return false;'>" + cws.I_TOOLBOX_CATEGORY_NAME + "</a>"]
				)
			});
			this.addChild(this.emptyCatalog);
		}
	},
	
	/*
	 * Change the default behavior to design. 
	 */
	_openPopup: function(){
		// summary: open the popup to the side of the current menu item
		this._stopPopupTimer();
		var from_item = this.focusedChild;
		var popup = from_item.popup;

		if(popup.isShowingNow){ return; }
		if(popup._prepareData){ popup._prepareData(); }
		dojo.addClass(from_item.arrowWrapper, "toolboxActionMenuSurround");

		popup.parentMenu = this;
		var self = this;
		dijit.popup.open({
			parent: this,
			popup: popup,
			around: from_item.arrowWrapper,
			orient: this.isLeftToRight() ? {'BL':'TL', 'TL':'BL'} : {'BR':'TR', 'TR':'BR'},
			onCancel: function(){
				// called when the child menu is canceled
				dijit.popup.close(popup);
				from_item.focus();	// put focus back on my node
				self.currentPopup = null;
			}
		});
		this.currentPopup = popup;

		if(popup.focus){
			setTimeout(dojo.hitch(popup, "focus"), 100);
		}
	},
	
	createNewItem:function(page) {
		return new com.ibm.mm.builder.iwidget.toolbox.ToolboxPopupMenuItem({
			id: page.getID(),
			popup: new com.ibm.mm.builder.iwidget.toolbox.ToolboxActionMenu({ entryModel: page, catagory: this.catagory }),
			entryModel: page
		});
	},
	
	onClose: function(){
		this.inherited(arguments);
		dojo.removeClass(this.targetNodeIds[0], "toolboxPanelItemHover");
		toolboxUtil.clearTooltipsTimer(this.toolTipTimers);
		toolboxUtil.clearTooltips();
		
		if (this.hoverBorder) { this.hoverBorder.hide(); }
	}
});
//todo it is possible to replace popitem with normal item to avoid to override _openpop method
dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxPopupMenuItem", dijit.PopupMenuItem, {
	
	templateString:
		'<tr class="dijitReset dijitMenuItem dojoDndItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"' +
			'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onItemClick">' +
			'<td class="dijitReset toolboxPopupMenuItemCell1" waiRole="presentation">' +
				'<img class="dijitMenuItemIcon" dojoAttachPoint="iconNode" alt=""></img>' +
			'</td>' +
			'<td class="dijitReset toolboxPopupMenuItemCell2">' +
				'<img class="warningIconNode" dojoAttachPoint="warningIconNode" alt="" title=""></img>' +
				'<span class="dijitMenuItemLabel" dojoAttachPoint="containerNode"></span>' +
			'</td>' +
			'<td class="dijitReset toolboxPopupMenuItemCell3" waiRole="presentation">' +
				'<div dojoAttachPoint="arrowWrapper" style="display: none" dojoAttachEvent="onclick:_onClick">' +
					'<div class="dijitMenuMode"><img dojoAttachPoint="arrowWrapperIcon" alt=""></img></div>' +
					'<span class="dijitMenuExpandA11y">+</span>' +
				'</div>' +
			'</td>' +
		'</tr>',
	
	postCreate: function(){
		this.imagePath = builderConfig.builderPath + "/images/";
		this.iconNode.src = this.entryModel.getIconURL() || this.imagePath + "generic_widget_icon.gif";
		
		if(builderConfig.isBidi){
			this.arrowWrapperIcon.src = this.imagePath + "context_menu_rtl.png";
			this.iconNode.src = iwidgetUtil.getRtlIconUrl(this.iconNode.src);
		}
		else {
			this.arrowWrapperIcon.src = this.imagePath + "context_menu.png";
		}
		
		this.domNode.setAttribute("dndtype", "iWidgetDefinition");
		this.domNode.setAttribute("dnddata", this.id);
		dijit.setWaiState(this.focusNode, "haspopup", "true");
		this.updateToolboxItemUI();
	},
	
	updateToolboxItemUI: function(){
		this.isTrusted = com.ibm.mm.builder.widget.sandboxEnabled ? iwidgetUtil.isTrustedWidget(this.entryModel.getID()) : true; 
		
		if (this.isTrusted) {
			this.warningIconNode.src = this.imagePath + "blank.gif";
			dojo.removeClass(this.warningIconNode,"warningIconNode");
		} else {
			this.warningIconNode.src = this.imagePath + "oneui/iconWarning.gif";
			this.warningIconNode.alt = "sandbox";
			dojo.addClass(this.warningIconNode,"warningIconNode");
		}
		
		var title = enablerUtil.getNodeTitle(this.entryModel);
		var limitedLength = (dojo.isIE ? 240 : 250) - (this.isTrusted ? 0 : 22);
		this.attr('label', htmlUtil.formatBlankSpace(
			htmlUtil.getStrWithLimit(title, this.containerNode, limitedLength)
		));
	},
	
	_onItemClick: function(){
		if(this.popup.isShowingNow){ 
			dijit.popup.close(this.popup);
			dojo.removeClass(this.arrowWrapper, "toolboxActionMenuSurround");
		}
	},
	
	_onClick:function(){
		this.closeTooltip(false);
		this.inherited(arguments);
		var tips = this.getParent().toolTipTimers;
		toolboxUtil.clearTooltipsTimer(tips);
	},
		
	_setSelected: function(selected){
		this.inherited(arguments);	
		if(selected){ return; }
		this.closeTooltip(true);
		var tips = this.getParent().toolTipTimers;
		toolboxUtil.clearTooltipsTimer(tips);
		dojo.removeClass(this.arrowWrapper, "toolboxActionMenuSurround");
		this._hideWarningBorder();
		this.arrowWrapper.style.display = "none";
	},
	
	focus: function(){
		this.inherited(arguments);
		if(!this.isTrusted){
			this.getParent().hoverBorder = this.getParent().hoverBorder || new com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuUntrustedItemHoverBorder();
			var selfDomNode = this.domNode;
			this.getParent().hoverBorder.show(selfDomNode);
			
			dojo.removeClass(selfDomNode,"dijitMenuItemHover");
			dojo.addClass(selfDomNode,"untrustedDijitMenuItemHover");
		}
		this.arrowWrapper.style.display = "";
		var queryClassName = this.isTrusted ? "dijitMenuItemHover" : "untrustedDijitMenuItemHover";
		dojo.forEach(dojo.query("." + queryClassName, this.domNode.parentNode), function(menuItem){
			if (this.id !== menuItem.id) {
				dojo.removeClass(menuItem, queryClassName);
			}
		}, this);
		var tips = this.getParent().toolTipTimers;
		var self = this;
		tips.push(setTimeout(function(){
			if (!self.tooltip) { self.createTooltip(); }
			if(self.getParent().isShowingNow){
				dijit.popup.open({
					parent: self,
					popup: self.tooltip,
					around:self.domNode,
					orient: self.isLeftToRight() ? {'BR':'BL','BL':'BR'} : {'BL':'BR','BR':'BL'},
					onExecute: function(){
						self.closeTooltip(true);
					},
					onCancel: function(){
						self.closeTooltip(true);
					},
					onClose: function(){
						self.closeTooltip(true);
					}
				});
			}
		}, 1000));
	},
	
	closeTooltip:function(needFocus){
		if(this.tooltip){
			dijit.popup.close(this.tooltip);
			this.tooltip = null;
			if(needFocus){ this.focus(); }
		}
	},
	
	_hideWarningBorder: function(){
		//hide all warning widget border
		if (!this.isTrusted) {
			dojo.removeClass(this.domNode, "untrustedDijitMenuItemHover");
			if (this.getParent().hoverBorder) {	this.getParent().hoverBorder.hide(); }
		}
		if (this.tooltipChildren) { this.changeTooltipStyle(false); }
	},
	/**
	 * create tooltip for this toolbox item
	 */
	createTooltip: function(){
		if(this.tooltip) { return; }
		var title = enablerUtil.getNodeTitle(this.entryModel);
		var desc = toolboxUtil.getDescription(this.getParent().catagory,this.id);
		if(title + desc != ""){
			var newT = (title.length > 0) ? "<b>" + title + "</b><br/>" : "";
			var tooltipLabel = "<div class='tooltipLabel'>" + newT + desc + "</div>";
			this.tooltip = new com.ibm.mm.builder.iwidget.toolbox.TooltipDialog({
				tipContent: tooltipLabel,
				isSandbox: !this.isTrusted
			});
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxActionMenu", com.ibm.mm.builder.widget.ShadowMenu,{
	
	postCreate: function(){
		this.inherited(arguments);
		dojo.addClass(this.domNode, "toolboxActionMenu");
		this.entryId = this.entryModel.getID();
    },
	
	canShowSandboxSeparator: function(){
		return com.ibm.mm.builder.widget.sandboxEnabled;
	},
	
	canToggleSandbox: function(){
		return !iwidgetUtil.isDisabledSandboxWidget(this.entryId) && !iwidgetUtil.isSandboxWidget(this.entryId) && this.entryModel.confirmSetMetaData() ;
	},
	
	canShowMarkAsTrustedSandBoxMenuItem: function(){
		return com.ibm.mm.builder.widget.sandboxEnabled && !dijit.byId(this.entryId).isTrusted;
	},
	
	canShowMarkAsUntrustedSandBoxMenuItem: function(){
		return com.ibm.mm.builder.widget.sandboxEnabled && dijit.byId(this.entryId).isTrusted;
	},
	
	canRemove: function(){
		return toolboxUtil.getCatalogModel().confirmRemove(this.entryModel);
	},
	
	addWidget: function(){
    	eventService.broadcastEvent("com.ibm.mashups.builder.addWidget", this.entryId);
	},
	
	embedWidget: function(){
		var widgetType = enablerUtil.getNodeTitle(this.entryModel);
		com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog(this.entryId, "widget", widgetType);
	},
	
	removeWidgetDefinition:function(){
		var _catModel = toolboxUtil.getCatalogModel();
        var _entryModel = _catModel.getCatalogEntryModel(this.catagory);
        var myElement = _entryModel.find(this.entryId).start();
        var menuTitle = enablerUtil.getNodeTitle(myElement);
        var warnInfo = htmlUtil.getSubstitute(cwm.I_TOOLBOX_DELETE_WARN_1, [menuTitle]);
        if (confirm(warnInfo)) {
            _entryModel.remove(this.entryId);
            _catModel.commit().start();
			toolboxUtil.getCatalogModel(true);
			eventService.broadcastEvent("com.ibm.mashups.builder.refreshPalette");
        }
	},
	
	toggleMark:function(){
		iwidgetUtil.toggleMarkedSandboxWidget(this.entryId);
		dijit.byId(this.entryId).updateToolboxItemUI();
		this.destroyDescendants();
		this.opened = false;
    },
	
	onOpen: function(){
		if (this.getChildren().length > 0) { return; }
		this.addChild(new com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuEmptyPlaceHolder({ needJoin: true }));
		
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.toolboxAction", this.entryId, null, {
			context: this
		});
		
		for (var i = 0; i < widgetMenus.length; ++i) {
			if (widgetMenus[i].isSeparator) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
				continue;
			}
			this.addChild(new dijit.MenuItem({
				label: widgetMenus[i].title,
				iconClass: widgetMenus[i].iconClass,
				disabled: !widgetMenus[i].enabled,
				onClick: widgetMenus[i].actionCallBackFunction
			}));
		}
		this.addChild(new com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuEmptyPlaceHolder());
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuSeparator", dijit.MenuSeparator, {
	
    templateString: '<tr><td colspan=4><div class="toolboxActMenuSeparator"></div></td></tr>'

});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuEmptyPlaceHolder", dijit.MenuSeparator, {

	templateString: '<tr><td colspan=4><div class="toolboxActMenuEmptyPlaceHolder" dojoAttachPoint="containerNode"></div></td></tr>',
	
	postCreate: function(){
		if (this.needJoin) { this.containerNode.innerHTML = '<div class="toolboxActMenuTopJoinPoint"></div>'; }
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuItemAvatar", [dijit._Widget, dijit._Templated], {

	templateString: '<div class="dojoDndItem"><img dojoAttachPoint="avatarIcon" /><span dojoAttachPoint="avatarTitle"></div>',
	
	postCreate:function(){
		var d = toolboxUtil.getWidgetDefinition(this.widgetDefId);
		this.avatarIcon.src = d.getIconURL();
		this.avatarTitle.innerHTML = enablerUtil.getNodeTitle(d);
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuUntrustedItemHoverBorder",[dijit._Widget, dijit._Templated],{
	
	templateString: '<div class="toolboxMenuUntrustedItemHoverBorder"></div>',
	
	postCreate:function(){
		this._createBorder();
	},
	
	_createBorder: function(){
		this.divs = [];
        for (var i = 0; i < 4; i++) {
            var borderHover = document.createElement("div");
            borderHover.style.display = "none";
            dojo.addClass(borderHover, "toolboxMenuUntrustedItemHoverBorder");
            this.divs.push(borderHover);
            document.body.appendChild(borderHover);
        }
	},
	
	show:function(dom){
		var coords = dojo.coords(dom, true);
		//left, top, right, bottom border
		dojo.marginBox(this.divs[0], {l:coords.x, t:coords.y, w:1, h:coords.h - 1});
		dojo.marginBox(this.divs[1], {l:coords.x, t:coords.y, w:coords.w - 2, h:1});
		dojo.marginBox(this.divs[2], {l:coords.x + coords.w - 2, t:coords.y, w:1, h:coords.h - 1});
		dojo.marginBox(this.divs[3], {l:coords.x, t:coords.y + coords.h - 2, w:coords.w - 2, h:1});
       
		dojo.forEach(this.divs, 'item.style.display="";');
	},
	
	hide:function(){
		dojo.forEach(this.divs, 'item.style.display="none";');
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.EmptyCatalogMessageBox",dijit.MenuItem,{
	
	postCreate:function(){
		this.inherited(arguments);
		this.iconNode.style.display = "none";
		this.arrowWrapper.style.display = "none";
		dojo.addClass(this.containerNode,"emptyCatalogMessage");
	},
	
	_onHover: function(){
		this.getParent().onItemHover(this);
	},
	_setSelected: function(selected){}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.TooltipDialog",dijit.TooltipDialog,{
	autofocus:false,
	
	postCreate:function(){
		dojo.addClass(this.domNode,"toolboxTooltip");
		var tooltipConnector = dojo.query(".dijitTooltipConnector",this.domNode)[0];
		if(this.isSandbox){ 
			dojo.addClass(this.domNode,"sandboxTooltip");
		} 
		dojo.addClass(tooltipConnector,(this.isSandbox ? "sandbox" : "default") +"DijitTooltipConnector"); 
		this.containerNode.innerHTML = this.tipContent;	
	},
		
	orient: function(/*DomNode*/node, /*String*/ aroundCorner, /*String*/ corner){
		var c = this._currentOrientClass;
		if(c){
			dojo.removeClass(this.domNode, c);
		}
		c = "dijitTooltip" + (aroundCorner.charAt(1) == 'L' ? "Left" : "Right");
		dojo.addClass(this.domNode, c);
		this._currentOrientClass = c;
	}
});

})();

}
