if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WirePane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WirePane"] = true;
/**
 @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WirePane");

dojo.require("dijit.Dialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas");

/**
// Basic code structure
	
display()
    initAllData()		// construct this.eventsMap
        wireUtil.getWidgetHandledEventsCSA2()
        wireUtil.getWidgetPublishedEventsCSA2()
    initWirePane()
    createSendEventsDiv()		// currentWidgetDiv + eventDivs
        createCurrentWidgetDiv()	
        // then create the event DIVs
        events = wireUtil.getWidgetHandledEventsCSA2()
        for(events) {
            this.connect(eventDiv, "onclick", this.onClickEvent)	// when click the send/receive event
        }

onClickEvent()
    // hide other not selected events
    createWidgetsDiv()		// show widgets that accept the events
        for(this.widgets) {
            if widget.hasMatchEvent
                this.connect(aWidgetDiv, "onclick", this.onClickWidget)
        }

onClickWidget()
    // hide other not selected widgets
    createWidgetEventsDiv()
        for(widget.events) {
            this.connect(aEventDiv, "onclick", this.onClickConEventDiv);
        }


onClickConEventDiv()
    connectEvent()
        addWire()
            wireModel.create(context)
            wireModel.insert(wire)
            
Some API calls:
var lcId = "097BF121A28FEF07A75C817F746ACA000002";
var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
var currentPage = navModel.find(pageId).start();
var layoutModel = navModel.getLayoutModel(currentPage);
var layoutControl = layoutModel.find(lcId).start();

var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start();
var widgetDef = widgetModel.getWidgetDefinitionByWindow(widgetWindow).start();
var title = widgetDef.getTitle(ibmConfig["default.locale"]);
 */
(function(){
    var cws = com.ibm.mm.builder.coreWidgetsStrings;
    var htmlUtil = com.ibm.mm.builder.utils.htmlUtil;
    
    dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WirePane", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.mm.builder.iwidget.wiringscreen", "templates/wirePane.html"),
        
        iContext: null,
        
        iwidgetId: "", //the widget uid 
        /*
         * The divs for display the corresponding info
         */
        wirePane: null,
        
        wirePaneDiv: null,
        
        wirePaneTitleDiv: null,
        
        wirePaneTitleDivLeft: null,
        
        sendIconDiv: null,
        
        sendWireCountDiv: null,
        
        receiveWireCountDiv: null,
        
        wirePaneTitleDivRight: null,
        
        recIconDiv: null,
        
        wirePaneCurrentWidgetDiv: null,
        
        wirePaneEventsDiv: null,
        
        wirePaneWidgetsDiv: null,
        
        wirePaneWidgetEventsDiv: null,
        
        wirePaneAdaptersDiv: null,
        
        firstAreaTopDiv: null,
        
        firstAreaDiv: null,
        
        firstAreaBottomDiv: null,
        
        secondAreaBottomDiv: null,
        
        secondAreaDiv: null,
        
        secondAreaTopDiv: null,
        
        thirdAreaDiv: null,
        
        bottomQmarkDiv: null,
        
        bottomDiv: null,
        
        prompter: null,
        
        widgetObj: null, // cache object, store all the widget-related info(name,icon...)
        highlightTimer: null,
        
        selectedEvent: "", //user selected event
        selectedWireWidget: "",
        
        //cache object, widgets which have match event
        widgets: null,
        
        //cache object, the events map for current event
        eventsMap: null,
        
        currentType: "", // current tab ( send/receive)
        grayTip: null, // The bottom Div for showing the Tip
        showPrompter: true,
        
        currentPageId: "", // Current page 
        localized: com.ibm.mashups.enabler.context.Factory.getLocalizedContext(),
        
        /**
         * current action step
         * 1: init
         * 2: choose event
         * 3: choose widget
         */
        actionStep: 1,
        
        clickedWidgetDiv: null, // the clicked widget div in the second pane
        allHanWires: 0,
        
        allPubWires: 0,
        
        titleFontStyle: {
            fontSize: "1.4em",
            fontFamily: "Arial,Helvetica,sans-serif",
            fontWeight: "bold"
        },
        
        defaultFontStyle: {
            fontSize: "1.4em",
            fontFamily: "Arial,Helvetica,sans-serif",
            fontWeight: "normal"
        },
        
        italicStyle: {
            fontSize: "1.4em",
            fontFamily: "Arial,Helvetica,sans-serif",
            fontWeight: "normal",
            fontStyle: "italic"
        },
        
        LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.wiringscreen.WirePane"),
        
        setSelectedEvent: function(eventName){
            this.selectedEvent = eventName;
        },
        
        /** 
         * Init the wire pane, place divs into right position and set the css class
         */
        initWirePane: function(){
        
            this.grayTip = document.createElement("div");
            this.grayTip.innerHTML = cws.I_WIRING_NO_MATCH_WIDGET;
            
            //Init the 2 main panes, hide the second at first
            dojo.fx.wipeOut({
                node: this.secondAreaDiv,
                duration: 10
            }).play();
            
            this.hideElement(this.secondAreaBottomDiv);
            
            //Init the title (text, icon)
            this.createTitleDiv();
            
            //Current widget's event
            this.wirePaneEventsDiv.setAttribute("id", "wirePaneEventsDiv_id");
            
            this.wirePaneWidgetsDiv.style.display = "none";
            
            dojo.fx.wipeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 10
            }).play();
            
            // Buttons on the right-bottom
            dojo.attr(this.buttonDivDone, "title", cws.I_WIRING_DONE);
            dojo.attr(this.buttonDivDone, "value", cws.I_WIRING_DONE);
            dojo.attr(this.buttonDivGraph, "title", cws.I_WIRING_SHOW_GRAPH);
            dojo.attr(this.buttonDivGraph, "value", cws.I_WIRING_SHOW_GRAPH);
            
            dojo.attr(this.wirePaneTitleDivLeft, "title", cws.I_WIRING_TITLE_RECEIVE);
            dojo.attr(this.wirePaneTitleDivRight, "title", cws.I_WIRING_TITLE_SEND);
            
            this.connect(this.closer, "onclick", this.closePrompter);
            
            this.connect(this.bottomQmarkDiv, "onclick", this.onClickQmark);
            
            var closeFun = function(){

                com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
                com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWidgetHighlight", this.iwidgetId);
            };
            
            this.connect(this.buttonDivDone, "onclick", dojo.hitch(this, closeFun));
            
            this.connect(this.buttonDivGraph, "onclick", dojo.hitch(this, function(){
                this.onClickShowGraph();
                com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWidgetHighlight", this.iwidgetId);
            }));
            
            if (this.iContext.dialogContainer) {
                this.connect(this.iContext.dialogContainer.closeButtonNode, "onclick", dojo.hitch(this, closeFun));
            }
        },
        
        /**
         * Util function, hide the div
         * @param {Object} div
         */
        hideElement: function(div){
            div.style.display = "none";
        },
        
        showElement: function(div){
            div.style.display = "";
        },
        
        /**
         * Display the prompter on the left side based on action step
         * @param {Object} step // in which step of current action, value should be 1,2,3
         * @param {Object} domNode
         */
        displayPrompter: function(step){
            //save the status for restore from hidden
            this.actionStep = step;
            
            if (this.showPrompter === false) {
                return;
            }
            var align = {
                'TL': 'TR',
                'BR': 'BL'
            };
            
            var properColor = this.getProperColor(step);
            
            var closerNode = dojo.query(".mumPrompterCloser", this.prompter)[0];
            htmlUtil.setClass(closerNode, "mumPrompterCloser");
            dojo.addClass(closerNode, "mumCloser" + properColor);
            
            //for a11y
            closerNode.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + properColor.toLowerCase() + "_closer.png' alt=''>";
            
            
            var contentNode = dojo.query(".mumPrompterContent", this.prompter)[0];
            htmlUtil.setClass(contentNode, "mumPrompterContent");
            dojo.addClass(contentNode, "mumContent" + properColor);
            
            var arrowNode = dojo.query(".mumPrompterArrow", this.prompter)[0];
            htmlUtil.setClass(arrowNode, "mumPrompterArrow");
            dojo.addClass(arrowNode, "mumPrompterArrow" + properColor);
            
            var textNode = dojo.query(".mumPrompterContentText", this.prompter)[0];
            var labelNode = dojo.query(".mumPrompterContentLabel", this.prompter)[0];
            htmlUtil.setClass(labelNode, "mumPrompterContentLabel");
            
            dojo.addClass(labelNode, "mumLabel" + properColor);
            dojo.attr(textNode, "keepBlankSpace", "");
            
            var truncatedWidgetName = htmlUtil.truncateWord(textNode, this.widgetObj.widgetname, 120);
            var truncatedSelectedEvent = htmlUtil.truncateWord(textNode, this.selectedEventTitle, 120);
            var truncatedWiredWidget = htmlUtil.truncateWord(textNode, this.selectedWireWidget, 120);
            switch (step) {
                case "1":
                    if (this.currentType == "Send") {
                        textNode.innerHTML = dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_1, [" " + truncatedWidgetName + " "]);
                    }
                    else {
                        textNode.innerHTML = dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_1, [" " + truncatedWidgetName + " "]);
                    }
                    labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_1;
                    htmlUtil.setClass(this.prompter, "mumPrompterAtEvents");
                    break;
                case "2":
                    if (this.currentType == "Send") {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_2, [" " + truncatedSelectedEvent + " "]), textNode, 585);
                    }
                    else {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_2, [" " + truncatedSelectedEvent + " "]), textNode, 530);
                    }
                    labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_2;
                    htmlUtil.setClass(this.prompter, "mumPrompterAtWidgets");
                    break;
                case "3":
                    if (this.currentType == "Send") {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_3, [" " + truncatedWiredWidget + " ", " " + truncatedSelectedEvent + " "]), textNode, 585);
                    }
                    else {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_3, [" " + truncatedWiredWidget + " ", " " + truncatedWidgetName + " "]), textNode, 530);
                    }
                    labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_3;
                    htmlUtil.setClass(this.prompter, "mumPrompterAtWidgetEvents");
                    break;
            }
            this.prompter.style.visibility = "visible";
            
            //		var borderTop = htmlUtil.getCurrentStyle(this.prompter,'border-top-width');
            //		var borderBottom = htmlUtil.getCurrentStyle(this.prompter,'border-bottom-width');
            
            var coord = dojo.coords(this.prompter);
            
            var coordArrow = dojo.coords(this.arrowNode);
            
            var temp = coord.h - coordArrow.h + coordArrow.t;
            
            this.arrowNodeMid.style.height = temp + "px";
        },
        
        closePrompter: function(){
            this.showPrompter = false;
            this.prompter.style.visibility = "hidden";
            this.bottomQmarkDiv.style.visibility = "visible";
        },
        
        onClickQmark: function(){
            this.showPrompter = true;
            this.prompter.style.visibility = "visible";
            this.displayPrompter(this.actionStep);
            this.bottomQmarkDiv.style.visibility = "hidden";
        },
        
        /**
         * This function will be invoked when user click the "Show Graph" button
         * Hide the wire interface and display the wiring graph
         */
        onClickShowGraph: function(){
        
            com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayWireGraph", this.iwidgetId);
            //		this.iContext.scope.displayWireGraph(this.iwidgetId,true);
        },
        /**
         * Get the proper color name based on current tab and action step
         * @param {Object} step: action step, should be 1/2/3
         * @return Blue or Green
         */
        getProperColor: function(step){
            switch (step) {
                case "1":
                    if (this.currentType == "Send") {
                        return "Green";
                    }
                    else {
                        return "Blue";
                    }
                    break;
                case "2":
                    if (this.currentType == "Send") {
                        return "Blue";
                    }
                    else {
                        return "Green";
                    }
                    break;
                case "3":
                    if (this.currentType == "Send") {
                        return "Blue";
                    }
                    else {
                        return "Green";
                    }
                    break;
            }
        },
        /**
         * Util function
         * Get the proper text for event name display
         * @param {Object} name
         */
        getProperName: function(name){
            var result = "<span title='" + name + "' >";
            if (name.length >= 18) {
                result = result + name.substring(0, 14) + "...";
            }
            else {
                result = result + name;
            }
            result = result + "</span>";
            return result;
        },
        
        /**
         * Util function
         * Get the proper text for widget title display
         * @param {Object} name
         */
        getProperTitle: function(name, len){
            var result = "<span tabindex='0' title='" + name + "' >";
            if (len === null) {
                len = 25;
            }
            if (name.length >= len) {
                result = result + name.substring(0, len - 4) + "...";
            }
            else {
                result = result + name;
            }
            result = result + "</span>";
            return result;
        },
        
        /**
         * Util function
         * Get the proper text for combined common data type
         * @param {Object} type
         */
        getShownType: function(type){
            var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
            return checker.getTypeLabel(type);
        },
        
        /**
         * Own wipeIn function to avoid the "height=auto" problem of dojo.fx.wipeIn
         * @param {Object} args
         */
        wipeIn: function(args){
            args.node = dojo.byId(args.node);
            var node = args.node, s = node.style, o;
            
            var anim = dojo.animateProperty(dojo.mixin({
                properties: {
                    height: {
                        // wrapped in functions so we wait till the last second to query (in case value has changed)
                        start: function(){
                            // start at current [computed] height, but use 1px rather than 0
                            // because 0 causes IE to display the whole panel
                            o = s.overflow;
                            s.overflow = "hidden";
                            if (s.visibility == "hidden" || s.display == "none") {
                                s.height = "1px";
                                s.display = "";
                                s.visibility = "";
                                return 1;
                            }
                            else {
                                var height = dojo.style(node, "height");
                                return Math.max(height, 1);
                            }
                        },
                        end: function(){
                            return node.scrollHeight;
                        }
                    }
                }
            }, args));
            
            this.connect(anim, "onEnd", function(){
                //s.height = "auto";
                s.overflow = o;
            });
            
            return anim; // dojo._Animation
        },
        
        /**
         * Util function
         * Generate a div element with the given css class
         * @param {string} className : the css class name for the div
         */
        createDivWithClass: function(className){
            var tempDiv = document.createElement("div");
            dojo.addClass(tempDiv, className);
            return tempDiv;
        },
        
        /**
         * Adjust the div class when switch between "Send" and "Receive" model
         */
        adjustDivsStyle: function(){
            this.adjustTitleDiv();
            htmlUtil.setClass(this.firstAreaTopDiv, "firstAreaTopDiv" + this.currentType);
            htmlUtil.setClass(this.firstAreaDiv, "mumFirstAreaDiv" + this.currentType);
            htmlUtil.setClass(this.secondAreaDiv, "mumSecondAreaDiv" + this.currentType);
            htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDiv" + this.currentType);
            htmlUtil.setClass(this.secondAreaBottomDiv, "mumSecondAreaBottomDiv" + this.currentType);
            this.hideElement(this.secondAreaBottomDiv);
        },
        
        /**
         * This function will be invoke when user click on the left(receive) tab on wire pane title
         * Switch between "Send" and "Receive" and change the pane content
         */
        onClickTitlePaneLeft: function(e){
            if (this.currentType == "Send") {
                this.currentType = "Receive";
                
                htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivLeftClick");
                htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivSendTab");
				
				dijit.setWaiState(this.wirePaneTitleDivLeft, "pressed", "true");
				dijit.setWaiState(this.wirePaneTitleDivLeft, "selected", "true");
				dojo.attr(this.wirePaneTitleDivLeft, "tabindex", "0");
				
				dijit.setWaiState(this.wirePaneTitleDivRight, "pressed", "false");
				dijit.setWaiState(this.wirePaneTitleDivRight, "selected", "false");
                dojo.attr(this.wirePaneTitleDivRight, "tabindex", "-1");
				
                htmlUtil.setClass(this.sendIconDiv, "mumSendIconDiv");
                htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDivClick");
                
                this.adjustDivsStyle();
                
                this.createReceiveEventsDiv();
                dojo.fx.wipeOut({
                    node: this.secondAreaDiv,
                    duration: 10
                }).play();
                this.hideElement(this.secondAreaBottomDiv);
            }
            this.displayPrompter("1");
			dijit.focus(this.wirePaneTitleDivLeft);
        },
		
        onKeyPresTitlePane: function(e){
			var key = e.keyCode;
			if (key === dojo.keys.LEFT_ARROW) {
                this.onClickTitlePaneLeft(e);
			} else if (key === dojo.keys.RIGHT_ARROW) {
				this.onClickTitlePaneRight(e);
			}
        },
        
        /**
         * This function will be invoke when user click on the right(send) tab on wire pane title
         * Switch between "Send" and "Receive" and change the pane content
         */
        onClickTitlePaneRight: function(e){
            if (this.currentType == "Receive") {
                this.currentType = "Send";
                
                htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivReceiveTab");
                htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivRightClick");
                
				dijit.setWaiState(this.wirePaneTitleDivRight, "pressed", "true");
				dijit.setWaiState(this.wirePaneTitleDivRight, "selected", "true");
				dojo.attr(this.wirePaneTitleDivRight, "tabindex", "0");
				
				dijit.setWaiState(this.wirePaneTitleDivLeft, "pressed", "false");
				dijit.setWaiState(this.wirePaneTitleDivLeft, "selected", "false");
                dojo.attr(this.wirePaneTitleDivLeft, "tabindex", "-1");
				
                htmlUtil.setClass(this.sendIconDiv, "mumSendIconDivClick");
                htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDiv");
                
                this.adjustDivsStyle();
                
                this.createSendEventsDiv();
                //wipe out other panes, only remain the first event pane
                dojo.fx.wipeOut({
                    node: this.secondAreaDiv,
                    duration: 10
                }).play();
                this.hideElement(this.secondAreaBottomDiv);
            }
            this.displayPrompter("1");
			dijit.focus(this.wirePaneTitleDivRight);
        },
        
        
        onMouseOverCurrentWidget: function(e){
            var widgetDiv = e.currentTarget;
            dojo.addClass(widgetDiv, "mumMouseOverCurrentWidget" + this.currentType);
        },
        
        onMouseOutCurrentWidget: function(e){
            var widgetDiv = e.currentTarget;
            dojo.removeClass(widgetDiv, "mumMouseOverCurrentWidget" + this.currentType);
        },
        onKeyPressEvent: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE: <support future extend>
                case dojo.keys.ENTER:
                    this.onClickEvent(e);
                    break;
            }
        },
        /**
         * This function will be invoke when user choose one event
         * Display the second widgets pane based on the selected event
         */
        onClickEvent: function(e){
        
            var eventDiv = e.currentTarget;
            
            //Display the return image
            var returnImgs = dojo.query(".mumEventDivReturnImg" + this.currentType, eventDiv);
            returnImgs[0].style.visibility = "visible";
            
            /*
             * Hide all other events
             */
            if (eventDiv.getAttribute("isClicked") != "true") {
            
                var eventName = eventDiv.getAttribute("eventName");
                this.selectedEvent = eventName;
                this.selectedEventTitle = eventDiv.getAttribute("eventTitle");
                this.widgets = this.eventsMap[this.currentType + "-" + eventName];
                
                //fade all other events
                var otherEvents = dojo.query(".mumEventDiv", this.wirePaneEventsDiv);
                if (otherEvents.length > 1) {
                    for (var i = 0; i < otherEvents.length; i++) {
                        var event = otherEvents[i];
                        if (event.getAttribute("eventName") != eventName) {
                            dojo.fx.combine([dojo.fadeOut({
                                node: event,
                                duration: 1000
                            }), dojo.fx.wipeOut({
                                node: event,
                                duration: 1000
                            })]).play();
                            event.setAttribute("isClicked", "false");
                        }
                    }
                }
                eventDiv.setAttribute("isClicked", "true");
                htmlUtil.setClass(eventDiv, "mumEventDivClicked" + this.currentType);
                //new event , hide the widget's event pane
                var matchWidgetCount = this.createWidgetsDiv();
                
                //show new link pane
                //htmlUtil.setClass(this.firstAreaDiv, "mumFirstAreaDivClick" + this.currentType);
                htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDivExpand" + this.currentType);
                this.showElement(this.secondAreaBottomDiv);
                
                dojo.fx.wipeIn({
                    node: this.secondAreaDiv,
                    duration: 1000
                }).play();
                this.showElement(this.secondAreaBottomDiv);
                this.displayPrompter("2");
                
            }
        },
        onKeyPressEventReturnImg: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE: <support future extend>
                case dojo.keys.ENTER:
                    this.onClickEventReturnImg(e);
                    break;
            }
        },
        /**
         * This function will be invoke when user click on the return image of one event.It will
         * 1. hide the return image
         * 2. display all other events
         * 3. hide the second pane
         * @param {event} e: the "onclick" event of the return image in selected event's div
         */
        onClickEventReturnImg: function(e){
        
            var eventDiv = e.currentTarget.parentNode;
            
            //restore to the org status, need to judget whether this event has wired with other event or not.
            htmlUtil.setClass(eventDiv, "mumEventDiv");
            var countDiv = dojo.query(".mumEventDivCount" + this.currentType, eventDiv);
            var count = parseInt(countDiv[0].innerHTML, 10);
            if (count > 0) {
                dojo.addClass(eventDiv, "mumEventDivWired");
            }
            
            if (eventDiv.getAttribute("isClicked") == "false") {
                return;
            }
            //hide the return image and the separator bar
            var returnImg = e.currentTarget;
            returnImg.style.visibility = "hidden";
            
            //fade all other events
            var otherEvents = dojo.query(".mumEventDiv", this.firstAreaDiv);
            if (otherEvents.length == 1) {
                otherEvents[0].setAttribute("isClicked", "false");
                dojo.stopEvent(e);
            }
            else 
                if (otherEvents.length > 1) {
                    for (var j = 0; j < otherEvents.length; j++) {
                        var event = otherEvents[j];
                        dojo.fx.combine([dojo.fadeIn({
                            node: event,
                            duration: 1000
                        }), this.wipeIn({
                            node: event,
                            duration: 1000
                        })]).play();
                        event.setAttribute("isClicked", "false");
                    }
                    dojo.stopEvent(e);
                }
            
            htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDiv" + this.currentType);
            
            dojo.fx.wipeOut({
                node: this.secondAreaDiv,
                duration: 500
            }).play();
            this.hideElement(this.secondAreaBottomDiv);
            dojo.fx.wipeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 10
            }).play();
            
            this.displayPrompter("1");
        },
        onKeyPressWidget: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE: <support future extend>
                case dojo.keys.ENTER:
                    this.onClickWidget(e);
                    break;
            }
        },
        /**
         * This function will be invoked when user click on one widget in the second area
         * @param {Event} e: the event object of the widget div's "onclick"
         */
        onClickWidget: function(e){
            var aWidgetDiv = e.currentTarget;
            this.selectedWireWidget = aWidgetDiv.getAttribute("widgetName");
            this.clickedWidgetDiv = aWidgetDiv;
            // Find the return image button
            var returnImgs = dojo.query(".mumWidgetDivReturnImg" + this.currentType, aWidgetDiv);
            returnImgs[0].style.visibility = "visible";
            //A11Y        
            returnImgs[0].setAttribute("tabindex", "0");
            
            var widgetId = e.currentTarget.getAttribute("widgetId");
            
            htmlUtil.setClass(aWidgetDiv, "mumWidgetClicked" + this.currentType);
            //dojo.addClass(aWidgetDiv, "mumWidgetClicked" + this.currentType);
            
            if (aWidgetDiv.getAttribute("isClicked") == "true") {
                return;
            }
            //fade out all other widgets
            var widgetDivs = dojo.query(".mumWireWidget" + this.currentType, this.wirePaneWidgetsDiv);
            if (widgetDivs.length > 0) {
                for (var i = 0; i < widgetDivs.length; i++) {
                    var widgetDiv = widgetDivs[i];
                    if (widgetDiv.getAttribute("widgetId") != widgetId) {
                        dojo.fx.combine([dojo.fadeOut({
                            node: widgetDiv,
                            duration: 1000
                        }), dojo.fx.wipeOut({
                            node: widgetDiv,
                            duration: 1000
                        })]).play();
                        widgetDiv.setAttribute("isClicked", false);
                    }
                }
            }
            //make the selected widget div
            aWidgetDiv.setAttribute("isClicked", "true");
            this.createWidgetEventsDiv(widgetId);
            //display the event-event wire pane
            dojo.fx.wipeIn({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            dojo.fadeIn({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            this.displayPrompter("3");
            
            //Remove the widget highlight
            window.clearTimeout(this.highlightTimer);
            dojo.publish(com.ibm.mm.builder.eventTopics.WirePane_OutWidget, [widgetId]);
        },
        onKeyPressWidgetReturnImg: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE: <support future extend>
                case dojo.keys.ENTER:
                    this.onClickWidgetReturnImg(e);
                    break;
            }
        },
        /**
         * This function will be invoked when user click on the return image button
         * on the right side of the selected widget's div
         * @param {Event} e: the "onclick" event of the widget div's return image
         */
        onClickWidgetReturnImg: function(e){
        
            //hide the return image
            e.currentTarget.style.visibility = "hidden";
            var aWidgetDiv = e.currentTarget.parentNode;
            
            if (aWidgetDiv.getAttribute("isClicked") == "false") {
                return;
            }
            
            htmlUtil.setClass(aWidgetDiv, "mumWireWidget" + this.currentType);
            
            //fade in other widgets
            var widgetDivs = dojo.query(".mumWireWidget" + this.currentType, this.wirePaneWidgetsDiv);
            if (widgetDivs.length > 1) {
                for (var i = 0; i < widgetDivs.length; i++) {
                    var widgetDiv = widgetDivs[i];
                    dojo.fadeIn({
                        node: widgetDiv,
                        duration: 1000
                    }).play();
                    this.wipeIn({
                        node: widgetDiv,
                        duration: 1000
                    }).play();
                    widgetDiv.setAttribute("isClicked", "false");
                }
            }
            //restore the widget div status
            aWidgetDiv.setAttribute("isClicked", "false");
            dojo.fx.wipeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            dojo.fadeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            dojo.stopEvent(e);
            this.displayPrompter("2");
        },
        
        onMouseOverWidget: function(e){
            var widgetDiv = e.currentTarget;
            if (widgetDiv.getAttribute("isClicked") == "true") {
                return;
            }
            var widgetId = widgetDiv.getAttribute("widgetId");
            var _this = this;
            this.highlightTimer = window.setTimeout(function(){
                //com.ibm.mm.builder.utils.iwidgetUtil.highlightWidget(widgetId);
                com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.highlightWidget", widgetId);
                //			_this.iContext.iEvents.publishEvent("widgetHighlighted", widgetId);
            }, 300);
        },
        
        onMouseOutWidget: function(e){
            var widgetDiv = e.currentTarget;
            if (widgetDiv.getAttribute("isClicked") == "true") {
                return;
            }
            var widgetId = widgetDiv.getAttribute("widgetId");
            var widget = this.getWidgetFromMap(widgetId);
            if (widget.totalWiredEvents > 0) {
                dojo.addClass(widgetDiv, "mumHasWiredEvent");
            }
            window.clearTimeout(this.highlightTimer);
            com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWidgetHighlight", widgetId);
            //		this.iContext.iEvents.publishEvent("widgetHighlightRemoved",widgetId);
        },
        
        /**
         * Invoke when user click on one widget's event div in the second pane
         * which has been click before(already display the wire div)
         * It will remove the wire div and restore the event back to normal status
         * @param {Object} aEventDiv: the clicked div
         */
        restoreEventDiv: function(aEventDiv){
        
            if (aEventDiv.getAttribute("isClicked")) { // Click before, now in expand status
                aEventDiv.setAttribute("isClicked", "false");
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                var actionDivs = dojo.query(".mumWidgetPaneEventActionDiv", aEventDiv);
                if (actionDivs && actionDivs.length > 0) {
                    for (var i = 0; i < actionDivs.length; i++) {
                        var actionDiv = actionDivs[i];
                        aEventDiv.removeChild(actionDiv);
                    }
                }
            }
        },
        
        /**
         * Invoke when user click on a matched event and want to connect
         * 1. restore all other event back to normal status
         * 2. generate a connection div and append to this event's div
         * @param {Event} e The "onclick" event of the selected event div
         */
        onClickConEventDiv: function(e){
        
            var aEventDiv = e.currentTarget;
            
            // Fetch all needed info and fill them into the new generated event connection div
            var id = aEventDiv.getAttribute("belongId");
            var eventName = aEventDiv.getAttribute("eventName");
            //here
            var aEvent = this.getEventFromWidget(id, eventName);
            
            var aEventInfoDiv = document.createElement("div");
            htmlUtil.setClass(aEventInfoDiv, "mumWidgetPaneEventInfoDiv" + this.currentType);
            
            // the text and checkbox 
            var checkMarkDiv = dojo.query(".checkMarkDiv", aEventDiv)[0];
            if (aEvent.isWired) {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                this.disconnectEvent(id, eventName);
                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' title='" + aEventDiv.firstChild.title + "'/>";
                aEventDiv.setAttribute("isChecked", "");
            }
            else {
                this.connectEvent(id, eventName);
                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true title='" + aEventDiv.firstChild.title + "'/>";
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                aEventDiv.setAttribute("isChecked", "checked");
            }
        },
        
        onMouseOverConEventDiv: function(e){
            var aEventDiv = e.currentTarget;
            var checked = aEventDiv.getAttribute("isChecked");
            if (checked == "checked") {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheckMouseOver" + this.currentType);
            }
            else {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivMouseOver");
            }
        },
        
        onMouseOutConEventDiv: function(e){
            var aEventDiv = e.currentTarget;
            var checked = aEventDiv.getAttribute("isChecked");
            if (checked == "checked") {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
            }
            else {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
            }
        },
        
        onClickWidgetPaneEventReturnImg: function(e){
        
            var aEventDiv = e.currentTarget.parentNode;
            
            var infoDiv = dojo.query(".mumWidgetPaneEventInfoDiv" + this.currentType, aEventDiv);
            var returnImg = dojo.query(".mumWidgetPaneEventReturnImg", aEventDiv);
            aEventDiv.removeChild(returnImg[0]);
            
            dojo.removeClass(infoDiv[0], "mumFloatLeft");
            
            var allEventsDiv = dojo.query(".mumWidgetPaneEventDiv", this.mumWidgetEventsDiv);
            var anotherEvent = null;
            for (var m = 0; m < allEventsDiv.length; m++) {
                anotherEvent = allEventsDiv[m];
                dojo.fadeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
                dojo.fx.wipeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
            }
            
            var allGrayEventsDiv = dojo.query(".mumWidgetPaneEventDivGray", this.mumWidgetEventsDiv);
            for (var n = 0; n < allGrayEventsDiv.length; n++) {
                anotherEvent = allGrayEventsDiv[n];
                dojo.fadeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
                dojo.fx.wipeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
            }
            
            dojo.stopEvent(e);
        },
        
        /**
         * Fetch the widget object from the cache
         * @param {Object} id: the widget id
         */
        getWidgetFromMap: function(id){
            var widget;
            for (var i = 0; i < this.widgets.length; i++) {
                widget = this.widgets[i];
                if (id == widget.id) {
                    return widget;
                }
            }
            return null;
        },
        
        /**
         * Get the event object from cache based on the widget id and event name
         * @param {Object} id : the id of the widget
         * @param {Object} eventName : the name of the event
         */
        getEventFromWidget: function(id, eventName){
            var event;
            for (var i = 0; i < this.widgets.length; i++) {
                var widget = this.widgets[i];
                if (id == widget.id) {
                    var events = widget.events;
                    for (var j = 0; j < events.length; j++) {
                        event = events[j];
                        
                        if (event.name == eventName) {
                            break;
                        }
                    }
                    break;
                }
            }
            return event;
        },
        
        /**
         * Update the cache after add/remove wire on the interaction interface
         * @param {string} sourceId
         * @param {string} sourceEvent
         * @param {string} targetId
         * @param {string} targetEvent
         */
        updateEventsMap: function(sourceId, sourceEvent, targetId, targetEvent, isAddWire){
            //var widgetsArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEvents(sourceId, sourceEvent,this.iContext.scope.layouts);
            //this.eventsMap["Send-" + sourceEvent] = widgetsArray;
            //this.widgets = widgetsArray;
            var eventName = targetEvent;
            var widgetId = targetId;
            if (this.currentType == "Receive") {
                eventName = sourceEvent;
                widgetId = sourceId;
            }
            var wireVar = -1;
            if (isAddWire) {
                wireVar = 1;
            }
            for (var i = 0; i < this.widgets.length; i++) {
                var widget = this.widgets[i];
                if (widgetId == widget.id) {
                    //Find the widget
                    widget.totalWiredEvents += wireVar;
                    var events = widget.events;
                    for (var j = 0; j < events.length; j++) {
                        var event = events[j];
                        
                        if (event.name == eventName) {
                            //Find the event
                            event.isWired = isAddWire;
                        }
                    }
                    break;
                }
            }
        },
        
        getWireModel: function(){
            // get current page
            var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
            
            var currentPage = navModel.find(this.currentPageId).start();
            var lm = navModel.getLayoutModel(currentPage);
            var wiringModel = lm.getWireModel();
            
            return wiringModel;
        },
        
        getLayoutModel: function(){
            // get current page
            var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
            
            var currentPage = navModel.find(this.currentPageId).start();
            var lm = navModel.getLayoutModel(currentPage);
            return lm;
        },
        
        getLayoutControl: function(lcId){
            var lc = this.getLayoutModel().find(lcId).start();
            return lc;
        },
        
        addWire: function(sourceId, sourceEvent, targetId, targetEvent, needUpdate){
        
            // Update WireModel 
            // Create the JSON object
            // Get WidgetWindow for layout control
            var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
            var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
            var currentPage = navModel.find(this.currentPageId).start();
            
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var sourcelc = this.getLayoutControl(sourceId);
            var sourceWidgetWindow = widgetModel.getWidgetWindow(sourcelc).start();
            
            var sourceEventProvider = widgetModel.getHierarchicalEventProvider(sourceWidgetWindow).start();
            var sourceEventObject = sourceEventProvider.getEvent(sourceEvent);
            
            
            var targetlc = this.getLayoutControl(targetId);
            var targetWidgetWindow = widgetModel.getWidgetWindow(targetlc).start();
            
            var targetEventProvider = widgetModel.getHierarchicalEventProvider(targetWidgetWindow).start();
            var targetEventObject = targetEventProvider.getEvent(targetEvent);
            
            
            var ctx = {};
            ctx.sourceWidgetId = sourceWidgetWindow;
            ctx.sourcePageId = currentPage;
            ctx.sourceEventId = sourceEventObject;
            ctx.targetWidgetId = targetWidgetWindow;
            ctx.targetPageId = currentPage;
            ctx.targetEventId = targetEventObject;
            // create the wire
            var wireModel = this.getWireModel();
            var wire = wireModel.create(ctx);
            // insert the wire
            if (wire) {
                wireModel.insert(wire, null);
            }
            if (needUpdate) {
                this.updateEventsMap(sourceId, sourceEvent, targetId, targetEvent, true);
            }			
            com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
        },
        
        
        removeWire: function(sourceId, sourceEvent, targetId, targetEvent, needUpdate){
            // Remove Wire from WireModel 
            var wireModel = this.getWireModel();
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var sourcelc = this.getLayoutControl(sourceId);
            var sourceWidgetWindow = widgetModel.getWidgetWindow(sourcelc).start();
            
            var targetlc = this.getLayoutControl(targetId);
            var targetWidgetWindow = widgetModel.getWidgetWindow(targetlc).start();
            
            var targetEventProvider = widgetModel.getHierarchicalEventProvider(targetWidgetWindow).start();
            var sourceEventProvider = widgetModel.getHierarchicalEventProvider(sourceWidgetWindow).start();
            var targetEventObj = targetEventProvider.getEvent(targetEvent);
            var sourceEventObj = sourceEventProvider.getEvent(sourceEvent);
            
            // Find the wire
            var aWire = null;
            
            var wireIter = wireModel.iterator();
            if (wireIter !== null) {
                wireIter.setCursorPosition(0);
                while (wireIter.hasNext()) {
                    var wireNode = wireIter.next();
                    // Need to see if this wire has the current layoutControl as target
                    if (wireNode.getTargetWidget().getID() == targetlc.getID() &&
                    wireNode.getSourceWidget().getID() == sourcelc.getID()) {
                        if (wireNode.getTargetEvent().getID() == targetEventObj.getID() &&
                        wireNode.getSourceEvent().getID() == sourceEventObj.getID()) {
                            aWire = wireNode;
                        }
                    }
                    
                }
            }
            
            if (aWire !== null) {
                // Remove the wire
                wireModel.remove(aWire);
            }
            if (needUpdate) {
                this.updateEventsMap(sourceId, sourceEvent, targetId, targetEvent, false);
            }			
        },
        
        disconnectEvent: function(id, eventName){
            if (this.currentType == "Send") {
                this.removeWire(this.iwidgetId, this.selectedEvent, id, eventName, true);
            }
            else {
                this.removeWire(id, eventName, this.iwidgetId, this.selectedEvent, true);
            }
            this.updateEventWireCount(id, -1);
        },
        
        connectEvent: function(id, eventName){
            if (this.currentType == "Send") {
                this.addWire(this.iwidgetId, this.selectedEvent, id, eventName, true);
            }
            else {
                this.addWire(id, eventName, this.iwidgetId, this.selectedEvent, true);
            }
            this.updateEventWireCount(id, 1);
        },
        
        /**
         * Update the wire count on the UI
         * @param {string} id: target widget id
         * @param {number} num: wire added(1)/ wire removed (-1)
         */
        updateEventWireCount: function(id, num){
            var eventDivs = dojo.query(".mumEventDivClicked" + this.currentType, this.wirePaneEventsDiv);
            for (var i = 0; i < eventDivs.length; i++) {
                var eventDiv = eventDivs[i];
                if (eventDiv.getAttribute("eventName") == this.selectedEvent) {
                    var countDiv = dojo.query(".mumEventDivCount" + this.currentType, eventDiv)[0];
                    var count;
                    if (countDiv.innerHTML == "" || countDiv.innerHTML === null) {
                        count = 0;
                    }
                    else {
                        count = parseInt(countDiv.innerHTML, 10);
                    }
                    count = count + num;
                    htmlUtil.setClass(countDiv, "mumEventDivCount" + this.currentType);
                    if (count > 0) {
                        countDiv.innerHTML = count;
                        if (count == 1) {
                            dojo.addClass(countDiv, "mumEventDivCountSingleWire" + this.currentType);
                        }
                        else {
                            dojo.addClass(countDiv, "mumEventDivCountMultiWire" + this.currentType);
                        }
                        
                    }
                    else {
                        countDiv.innerHTML = "";
                    }
                    
                    //for a11y
                    this._insertEventA11yHint(this.currentType, eventDiv, count);
                }
            }
            var curWireIcon = dojo.query(".mumCurrentWidgetArrow" + this.currentType, this.wirePaneCurrentWidgetDiv)[0];
            var currentWidgetName = dojo.query(".mumCurrentWidgetName" + this.currentType, this.wirePaneCurrentWidgetDiv)[0];
            if (this.currentType == "Send") {
                this.allPubWires += num;
                if (builderConfig.isBidi) {
                    this.sendIconDiv.innerHTML = "(" + this.allPubWires + ")";
                }
                else {
                    this.sendWireCountDiv.innerHTML = "(" + this.allPubWires + ")";
                }
                //update the UI of the current widget
                if (this.allPubWires === 0) {
                    dojo.addClass(curWireIcon, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 375, this.titleFontStyle);
                }
                else 
                    if (this.allPubWires == 1 && num == 1) {
                        dojo.removeClass(curWireIcon, "mumHiddenElement");
                        htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 345, this.titleFontStyle);
                    }
            }
            else {
                this.allHanWires += num;
                if (builderConfig.isBidi) {
                    this.recIconDiv.innerHTML = "(" + this.allHanWires + ")";
                }
                else {
                    this.receiveWireCountDiv.innerHTML = "(" + this.allHanWires + ")";
                }
                //update the UI of the current widget
                if (this.allHanWires === 0) {
                    dojo.addClass(curWireIcon, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 375, this.titleFontStyle);
                }
                else 
                    if (this.allHanWires == 1 && num == 1) {
                        dojo.removeClass(curWireIcon, "mumHiddenElement");
                        htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 345, this.titleFontStyle);
                    }
            }
            //update the UI of the selected widget
            var widget = this.getWidgetFromMap(id);
            var arrow = dojo.query(".mumWireIndicator" + this.currentType, this.clickedWidgetDiv)[0];
            var widgetname = dojo.query(".mumWireWidgetTitle", this.clickedWidgetDiv)[0];
            
            if (widget.totalWiredEvents > 0) {
                arrow.style.display = "";
                htmlUtil.setNodeTitleWithStyle(widgetname.title, widgetname, 345, this.titleFontStyle);
            }
            else {
                htmlUtil.setNodeTitleWithStyle(widgetname.title, widgetname, 375, this.titleFontStyle);
                arrow.style.display = "none";
            }
        },
        
		/**
		 * Invoked when you click the target widget to wire
		 * Create the DIV that contains all the match events
		 * @param {Object} id
		 */
        createWidgetEventsDiv: function(id){
            this.wirePaneWidgetEventsDiv.innerHTML = "";
            var widgetsTitleDiv = document.createElement("div");
            if (this.currentType == "Send") {
                htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivSend");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETEVENTS_SEND, widgetsTitleDiv, 425, this.titleFontStyle);
            }
            else 
                if (this.currentType == "Receive") {
                    htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivReceive");
                    htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETEVENTS_RECEIVE, widgetsTitleDiv, 425, this.titleFontStyle);
                }
            htmlUtil.setClass(this.wirePaneWidgetEventsDiv, "mumWidgetEventsDiv" + this.currentType);
            var mumWidgetEventsContentDiv = this.createDivWithClass("mumWidgetEventsContentDiv" + this.currentType);
            for (var i = 0; i < this.widgets.length; i++) {
                var aWidget = this.widgets[i];
                if (aWidget.id == id) {
                
                    var events = aWidget.events;
                    for (var j = 0; j < events.length; j++) {
                        var aEvent = events[j];
                        var eventName = aEvent.name;
                        var aEventDiv = document.createElement("div");
                        aEventDiv.setAttribute("belongId", id);
                        aEventDiv.setAttribute("eventName", eventName);
                        
                        if (aEvent.isMatch) {
                        
                            this.connect(aEventDiv, "onclick", this.onClickConEventDiv);
                            this.connect(aEventDiv, "onmouseover", this.onMouseOverConEventDiv);
                            this.connect(aEventDiv, "onmouseout", this.onMouseOutConEventDiv);
                            
                            var checkMarkDiv = document.createElement("div");
                            dojo.addClass(checkMarkDiv, "checkMarkDiv");
                            dojo.addClass(checkMarkDiv, "mumFloatLeft");
                            
                            if (aEvent.isWired) {
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true>";
                                aEventDiv.setAttribute("isChecked", "checked");
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                            }
                            else {
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox'>";
                                aEventDiv.setAttribute("isChecked", "");
                            }
                            
                            var aEventInfoDiv = this.createDivWithClass("mumWidgetPaneEventInfoDiv" + this.currentType);
                            
                            var title = "";
                            var description = "";
                            var oneEvent = null;

                            var layoutControl = this.getLayoutControl(id);
                            
                            oneEvent = null;
                            
                            if (layoutControl) {
                                // get widgetmodel
                                var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
                                
                                // get widgetWindow
                                var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start();
                                var eventProvider = widgetModel.getHierarchicalEventProvider(widgetWindow).start();
                                // Find target event
                                oneEvent = eventProvider.getEvent(eventName);
                            }
                            
                            title = oneEvent.getTitle(dojo.locale) ? oneEvent.getTitle(dojo.locale) : (oneEvent.getTitle("en") ? oneEvent.getTitle("en") : oneEvent.getName());
                            description = oneEvent.getDescription(dojo.locale) ? oneEvent.getDescription(dojo.locale) : oneEvent.getName();
                            
                            var eventDivText1 = this.createDivWithClass("mumWidgetPaneEventInfoText" + this.currentType);
                            dojo.addClass(eventDivText1, "mumEventDivText1");
                            var eventDivText3 = this.createDivWithClass("mumWidgetPaneEventInfoText" + this.currentType);
                            dojo.addClass(eventDivText3, "mumEventDivText3");
                            
                            eventDivText1.title = title;
                            eventDivText1.innerHTML = htmlUtil.escapeString(title);
                            
                            var payloadType = this.getShownType(aEvent.payloadType);
                            eventDivText3.title = payloadType;
                            eventDivText3.innerHTML = htmlUtil.escapeString(payloadType);
                            
                            var wrapperDiv1 = document.createElement("div");
                            wrapperDiv1.appendChild(eventDivText1);
                            
                            var wrapperDiv3 = document.createElement("div");
                            wrapperDiv3.appendChild(eventDivText3);
                            
                            //A11Y
                            if (aEvent.isWired) {
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true title='" + aEventInfoDiv.title + "' />";
                                aEventDiv.setAttribute("isChecked", "checked");
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                            }
                            else {
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' title='" + aEventInfoDiv.title + "' />";
                                aEventDiv.setAttribute("isChecked", "");
                            }
                            aEventInfoDiv.appendChild(checkMarkDiv);
                            
                            var storeEventDivInnerHTML = aEventInfoDiv.innerHTML;
                            
                            //construct the event content
                            var eventContent;
                            var eventTitle = null;
                            if (this.currentType == "Send") {
                                // To fix bug 3218 3228
                                eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_RECEIVE, [title, this.getShownType(aEvent.payloadType), description]);
                                aEventInfoDiv.title = eventTitle;
                                //construct the event content
                                eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_RECEIVE, [wrapperDiv1.innerHTML, '<div class="mumWidgetPaneEventInfoTextMid">', '</div>', wrapperDiv3.innerHTML]);
                                
                            }
                            else {
                                // To fix bug 3218 3228
                                eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_SEND, [eventName, this.getShownType(aEvent.payloadType), description]);
                                aEventInfoDiv.title = eventTitle;
                                eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_SEND, [wrapperDiv1.innerHTML, '<div class="mumWidgetPaneEventInfoTextMid">', '</div>', wrapperDiv3.innerHTML]);
                            }
                            aEventInfoDiv.innerHTML = aEventInfoDiv.innerHTML + eventContent;
                            
                            eventDivText1 = dojo.query(".mumEventDivText1", aEventInfoDiv)[0];
                            var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1, this.defaultFontStyle);
                            
                            eventDivText3 = dojo.query(".mumEventDivText3", aEventInfoDiv)[0];
                            var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3, this.defaultFontStyle);
                            
                            var eventDivText2 = dojo.query(".mumWidgetPaneEventInfoTextMid", aEventInfoDiv)[0];
                            var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2, this.italicStyle);
                            eventDivText2.title = eventDivText2.innerHTML;
                            
                            var totalWidth = dojo.isIE ? 380 : 395;
                            
                            if (div1Width + div2Width + div3Width > totalWidth) {
                            
                                var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
                                var widthLeftFor3 = widthLeft - div1Width;
                                var widthLeftFor1 = widthLeft - div3Width;
                                
                                if (widthLeftFor3 > 60) { //try to only truncate one only
                                    div3Width = widthLeftFor3;
                                    htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                                }
                                else 
                                    if (widthLeftFor1 > 60) {
                                        div1Width = widthLeftFor1;
                                        htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                                    }
                                    else {
                                        div1Width = widthLeft * 0.6;
                                        div3Width = widthLeft * 0.4;
                                        htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                                        htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                                    }
                            }
                            aEventDiv.appendChild(aEventInfoDiv);
                        }
                        mumWidgetEventsContentDiv.appendChild(aEventDiv);
                        
                    }
                    break;
                }
            }
            var mumWidgetEventsBottomDiv = this.createDivWithClass("mumWidgetEventsBottomDiv" + this.currentType);
            
            this.wirePaneWidgetEventsDiv.appendChild(widgetsTitleDiv);
            this.wirePaneWidgetEventsDiv.appendChild(mumWidgetEventsContentDiv);
            this.wirePaneWidgetEventsDiv.appendChild(mumWidgetEventsBottomDiv);
        },
        
        /**
         * This function will be invoked when user click on one event in first area.
         * 1. Init and display the second area
         * 2. Render every other widget based on the info fetched by wireUtil
         * 3. Place the return image button and the tip
         */
        createWidgetsDiv: function(){
        
            //reset the whole widgets pane
            this.wirePaneWidgetsDiv.innerHTML = "";
            this.wirePaneWidgetEventsDiv.innerHTML = "";
            this.hideElement(this.wirePaneWidgetEventsDiv);
            htmlUtil.setClass(this.wirePaneWidgetsDiv, "mumPaneDiv");
            //Init the tip div
            htmlUtil.setClass(this.grayTip, "mumWireWidgetTip" + this.currentType);
            this.grayTip.innerHTML = cws.I_WIRING_NO_MATCH_WIDGET;
            //Init the title
            var widgetsTitleDiv = document.createElement("div");
            if (this.currentType == "Send") {
                htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivSend");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETS_SEND, widgetsTitleDiv, 425, this.titleFontStyle);
                //            widgetsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_WIDGETS_SEND,40);
            }
            else 
                if (this.currentType == "Receive") {
                    htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivReceive");
                    htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETS_RECEIVE, widgetsTitleDiv, 425, this.titleFontStyle);
                //                widgetsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_WIDGETS_RECEIVE,40);
                }
            // The content pane in the middle
            var wirePaneWidgetsContentDiv = this.createDivWithClass("mumWidgetsContentDiv" + this.currentType);
            this.wirePaneEventsDiv.appendChild(wirePaneWidgetsContentDiv);
            
            var matchWidgetCount = 0;
            var preFetchId;
            //Render every other widgets in the widgets pane if they have at least one event can be wired with current widget's event
            for (var i = 0; i < this.widgets.length; i++) {
                var aWidget = this.widgets[i];
                if (aWidget.hasMatchEvent) { // has event can be wired to this widgets, create div
                    matchWidgetCount++;
                    preFetchId = aWidget.id;
                    var aWidgetDiv = document.createElement("div");
                    aWidgetDiv.setAttribute("widgetId", aWidget.id);
                    aWidgetDiv.setAttribute("isClicked", "false");
                    aWidgetDiv.setAttribute("widgetName", aWidget.type);
                    //A11Y
                    aWidgetDiv.setAttribute("title", aWidget.type);
                    aWidgetDiv.setAttribute("tabindex", "0");
                    dojo.addClass(aWidgetDiv, "mumWireWidget" + this.currentType);
                    
                    //arrow to indicate is currently wired with the widget
                    var wireIndicator = document.createElement("div");
                    this.connect(aWidgetDiv, "onmouseover", this.onMouseOverWidget);
                    this.connect(aWidgetDiv, "onmouseout", this.onMouseOutWidget);
                    this.connect(aWidgetDiv, "onclick", this.onClickWidget);
                    //A11Y
                    //dojo.connect(aWidgetDiv, "onfocus", this, "onMouseOverWidget");
                    //dojo.connect(aWidgetDiv, "onblur", this, "onMouseOutWidget");
                    this.connect(aWidgetDiv, "onkeypress", this.onKeyPressWidget);
                    
                    //TODO: CSA2 Replace - How to get icon for widget (use widget definition)
                    // note out to resolve url?
                    var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
                    var titleIcon = widgetUtil.getWidgetInstanceIcon(aWidget.id) || (builderConfig.builderPath + "/images/generic_widget_icon.gif");
                    
                    var aWidgetImg = document.createElement("div");
                    aWidgetImg.innerHTML = "<img src='" + titleIcon + "' class='mumWirePaneWidgetIcon' alt=''>";
                    htmlUtil.setClass(aWidgetImg, "mumWireWidgetImg");
                    aWidgetDiv.appendChild(aWidgetImg);
                    
                    var aWidgetTitle = document.createElement("div");
                    htmlUtil.setClass(aWidgetTitle, "mumWireWidgetTitle");
                    aWidgetDiv.appendChild(aWidgetTitle);
                    
                    wireIndicator.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + (this.currentType === "Send" ? "receive" : "send") + (builderConfig.isBidi ? "_arrow_rtl.png' alt=''>" : "_arrow.png' alt=''>");
                    htmlUtil.setClass(wireIndicator, "mumWireIndicator" + this.currentType);
                    
                    //deal with the inidcator
                    wireIndicator.style.display = "none";
                    //                wireIndicator.style.visibility = "hidden";
                    if (aWidget.totalWiredEvents > 0) {
                        dojo.addClass(aWidgetDiv, "mumHasWiredEvent");
                        wireIndicator.style.display = "";
                        htmlUtil.setNodeTitleWithStyle(aWidget.type, aWidgetTitle, 345, this.titleFontStyle);
                        //                    wireIndicator.style.visibility = "visible";
                    }
                    else {
                        htmlUtil.setNodeTitleWithStyle(aWidget.type, aWidgetTitle, 375, this.titleFontStyle);
                    }
                    
                    var widgetDivReturnImg = document.createElement("div");
                    htmlUtil.setClass(widgetDivReturnImg, "mumWidgetDivReturnImg" + this.currentType);
                    this.connect(widgetDivReturnImg, "onclick", this.onClickWidgetReturnImg);
                    
                    //A11Y-todo
                    this.connect(widgetDivReturnImg, "onkeypress", this.onKeyPressWidgetReturnImg);
                    dojo.attr(widgetDivReturnImg, "title", cws["I_WIRING_OTHER_WIDGETS_" + this.currentType.toUpperCase()]);
                    widgetDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + (this.currentType == "Send" ? "blue" : "green") + "_expand.png' alt=''>";
                    
                    
                    widgetDivReturnImg.style.visibility = "hidden";
                    widgetDivReturnImg.setAttribute("tabindex", "0");
                    aWidgetDiv.appendChild(widgetDivReturnImg);
                    aWidgetDiv.appendChild(wireIndicator);
                    wirePaneWidgetsContentDiv.appendChild(aWidgetDiv);
                }
            }
            this.wirePaneWidgetEventsDiv.innerHTML = "";
            //this.wirePaneWidgetsDiv.appendChild(this.wirePaneWidgetEventsDiv);
            
            //The bottom pane, only contains one round corner image
            var wirePaneWidgetsBottomDiv = this.createDivWithClass("mumWidgetsBottomDiv" + this.currentType);
            
            this.wirePaneWidgetsDiv.appendChild(widgetsTitleDiv);
            //If there is no widget which contains event can be wired with this widget's event, show the tip
            if (matchWidgetCount === 0) {
                wirePaneWidgetsContentDiv.appendChild(this.grayTip);
            }
            
            this.wirePaneWidgetsDiv.appendChild(wirePaneWidgetsContentDiv);
            this.wirePaneWidgetsDiv.appendChild(wirePaneWidgetsBottomDiv);
            
            this.wirePaneWidgetsDiv.style.display = "";
            this.LOGGER.exiting("WirePane_createWidgetsDiv");
            return matchWidgetCount;
        },
        
        /**
         * This function will be invoked every time a new wire pane is poped up.
         * Fetch all related events' and wire data for current widget. Wrap them into Object "eventsMap".
         */
        initAllData: function(){
        
            this.eventsMap = {};
            var hEvents = null;
            var pEvents = null;
            var hanEvent = null;
            var pubEvent = null;
            
            var currentPID = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
            this.currentPageId = currentPID;
            
            
            var layoutControl = this.getLayoutControl(this.iwidgetId);
            
            //			var hEvents = widgetWrapper.getWidgetHandledEvents();
            hEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(layoutControl);
            //			var pEvents = widgetWrapper.getWidgetPublishedEvents();
            pEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(layoutControl);
            
            /* *** */
            this.allHanWires = 0;
            this.allPubWires = 0;
            var lcArray = null;
            // LayoutModel has the controls
            if (hEvents) {
                for (var n = 0; n < hEvents.length; n++) {
                    hanEvent = hEvents[n];
                    
                    lcArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchPubEventsCSA2(layoutControl, hanEvent.getName(), currentPID);
                    for (var i = 0; i < lcArray.length; i++) {
                        this.allHanWires = this.allHanWires + lcArray[i].wiredEvents.length;
                    }
                    this.eventsMap["Receive-" + hanEvent.getName()] = lcArray;
                }
            }
            
            if (pEvents) {
                for (var m = 0; m < pEvents.length; m++) {
                    pubEvent = pEvents[m];
                    
                    lcArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEventsCSA2(layoutControl, pubEvent.getName(), currentPID);
                    for (var j = 0; j < lcArray.length; j++) {
                        this.allPubWires = this.allPubWires + lcArray[j].wiredEvents.length;
                    }
                    this.eventsMap["Send-" + pubEvent.getName()] = lcArray;
                }
            }
        },
        
        /**
         * Generate the receive Events pane of current widget
         */
        createReceiveEventsDiv: function(){
        
            this.createCurrentWidgetDiv();
            
            this.wirePaneEventsDiv.innerHTML = "";
            htmlUtil.setClass(this.wirePaneEventsDiv, "mumEventsDiv");
            htmlUtil.setClass(this.grayTip, "mumWireWidgetTipSend");
            this.grayTip.innerHTML = cws.I_WIRING_NO_RECEIVE_EVENTS;
            
            var eventsTitleDiv = document.createElement("div");
            htmlUtil.setClass(eventsTitleDiv, "mumEventsTitleDivReceive");
            
            htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_EVENTS_RECEIVE, eventsTitleDiv, 425, this.titleFontStyle);
            
            this.wirePaneEventsDiv.appendChild(eventsTitleDiv);
            
            var hEvents = [];
            
            var layoutControl = this.getLayoutControl(this.iwidgetId);
            hEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(layoutControl);
            
            var wirePaneEventsContentDiv = this.createDivWithClass("mumEventsContentDiv" + this.currentType);
            this.wirePaneEventsDiv.appendChild(wirePaneEventsContentDiv);
            
            var hasEventToShow = false;
            
            for (var n = 0; n < hEvents.length; n++) {
                var hanEvent = hEvents[n];
                
                var eventDiv = document.createElement("div");
                htmlUtil.setClass(eventDiv, "mumEventDiv");
                
                wirePaneEventsContentDiv.appendChild(eventDiv);
                hasEventToShow = true;
                
                var title = "";
                var description = "";
                var shownType = "";
                var shownEventName = "";

                title = hanEvent.getTitle(dojo.locale);
                if (!title) {
                    title = hanEvent.getName();
                }
                
                description = hanEvent.getDescription(dojo.locale);
                if (!description) {
                    description = hanEvent.getName();
                }
                shownType = hanEvent.getPayloadType();
                shownEventName = hanEvent.getName();
                
                // To fix bug 3218 3228
                var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_RECEIVE, [title, this.getShownType(shownType), description]);
                eventDiv.title = eventTitle;
                
                var widgetsArray = this.eventsMap["Receive-" + shownEventName];
                var wiredEventCount = 0;
                for (var i = 0; i < widgetsArray.length; i++) {
                    wiredEventCount = wiredEventCount + widgetsArray[i].totalWiredEvents;
                }
                
                var eventDivCount = document.createElement("div");
                htmlUtil.setClass(eventDivCount, "mumEventDivCount" + this.currentType);
                
                //if this event already has wired with other events
                if (wiredEventCount > 0) {
                    eventDivCount.innerHTML = wiredEventCount;
                    dojo.addClass(eventDiv, "mumEventDivWired");
                    if (wiredEventCount == 1) {
                        dojo.addClass(eventDivCount, "mumEventDivCountSingleWire" + this.currentType);
                    }
                    else {
                        dojo.addClass(eventDivCount, "mumEventDivCountMultiWire" + this.currentType);
                    }
                }
                
                var eventDivReturnImg = document.createElement("div");
                eventDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/blue_expand.png' alt=''>";
                
                htmlUtil.setClass(eventDivReturnImg, "mumEventDivReturnImg" + this.currentType);
                this.connect(eventDivReturnImg, "onclick", this.onClickEventReturnImg);
                eventDivReturnImg.style.visibility = "hidden";
                //A11Y
                this.connect(eventDivReturnImg, "onkeypress", this.onKeyPressEventReturnImg);
                eventDivReturnImg.setAttribute("tabindex", "0");
                dojo.attr(eventDivReturnImg, "title", cws["I_WIRING_OTHER_EVENTS_" + this.currentType.toUpperCase()]);
                
                var eventDivVline = document.createElement("div");
                htmlUtil.setClass(eventDivVline, "grayBar");
                eventDivVline.style.visibility = "hidden";
                
                eventDiv.setAttribute("eventName", shownEventName);
                eventDiv.setAttribute("eventTitle", title);
                eventDiv.setAttribute("isClicked", "false");
                //A11Y
                eventDiv.setAttribute("tabindex", "0");
                eventDiv.appendChild(eventDivCount);
                
                var eventDivText1 = this.createDivWithClass("mumEventDivTextReceive");
                dojo.addClass(eventDivText1, "mumEventDivText1");
                eventDivText1.title = title;
                eventDivText1.innerHTML = htmlUtil.escapeString(title);
                
                var eventDivText3 = this.createDivWithClass("mumEventDivTextReceive");
                dojo.addClass(eventDivText3, "mumEventDivText3");
                var payloadType = this.getShownType(shownType);
                eventDivText3.title = payloadType;
                eventDivText3.innerHTML = htmlUtil.escapeString(payloadType);
                
                var wrapperDiv1 = document.createElement("div");
                wrapperDiv1.appendChild(eventDivText1);
                
                var wrapperDiv3 = document.createElement("div");
                wrapperDiv3.appendChild(eventDivText3);
                
                var storeEventDivInnerHTML = eventDiv.innerHTML;
                
                //construct the event content
                var eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_RECEIVE, [wrapperDiv1.innerHTML, '<div class="mumEventDivText2">', '</div>', wrapperDiv3.innerHTML]);
                eventDiv.innerHTML = eventDiv.innerHTML + eventContent;
                
                eventDivText1 = dojo.query(".mumEventDivText1", eventDiv)[0];
                var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1, this.defaultFontStyle);
                
                eventDivText3 = dojo.query(".mumEventDivText3", eventDiv)[0];
                var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3, this.defaultFontStyle);
                
                var eventDivText2 = dojo.query(".mumEventDivText2", eventDiv)[0];
                var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2, this.italicStyle);
                eventDivText2.title = eventDivText2.innerHTML;
                
                var totalWidth = dojo.isIE ? 370 : 380;
                
                if (div1Width + div2Width + div3Width > totalWidth) {
                
                    var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
                    var widthLeftFor3 = widthLeft - div1Width;
                    var widthLeftFor1 = widthLeft - div3Width;
                    
                    if (widthLeftFor3 > 60) { //try to only truncate one only
                        div3Width = widthLeftFor3;
                        htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                    }
                    else 
                        if (widthLeftFor1 > 60) {
                            div1Width = widthLeftFor1;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                        }
                        else {
                            div1Width = widthLeft * 0.6;
                            div3Width = widthLeft * 0.4;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                            htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                        }
                }
                eventDiv.appendChild(eventDivReturnImg);
                this.connect(eventDiv, "onclick", this.onClickEvent);
                //A11Y
                this.connect(eventDiv, "onkeypress", this.onKeyPressEvent);
                this._insertEventA11yHint("Receive", eventDiv, wiredEventCount);
            }
            
            if (!hasEventToShow) {
                wirePaneEventsContentDiv.appendChild(this.grayTip);
            }
            
            var wirePaneEventsBottomDiv = this.createDivWithClass("mumEventsBottomDiv" + this.currentType);
            this.wirePaneEventsDiv.appendChild(wirePaneEventsBottomDiv);
        },
        
        /**
         * Generate the send Events pane of current widget
         */
        createSendEventsDiv: function(){
        
            this.createCurrentWidgetDiv();
            
            //reset the whole wire pane
            this.wirePaneEventsDiv.innerHTML = "";
            htmlUtil.setClass(this.wirePaneEventsDiv, "mumEventsDiv");
            htmlUtil.setClass(this.grayTip, "mumWireWidgetTipReceive");
            this.grayTip.innerHTML = cws.I_WIRING_NO_SEND_EVENTS;
            //Init the title
            var eventsTitleDiv = document.createElement("div");
            htmlUtil.setClass(eventsTitleDiv, "mumEventsTitleDivSend");
            htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_EVENTS_SEND, eventsTitleDiv, 425, this.titleFontStyle);
            
            //        eventsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_EVENTS_SEND,40);
            
            this.wirePaneEventsDiv.appendChild(eventsTitleDiv);
            //Fetch the send events' info
            
            var pEvents = [];
            var layoutControl = this.getLayoutControl(this.iwidgetId);
            pEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(layoutControl);
            
            var wirePaneEventsContentDiv = this.createDivWithClass("mumEventsContentDiv" + this.currentType);
            this.wirePaneEventsDiv.appendChild(wirePaneEventsContentDiv);
            
            var hasEventToShow = false;
            
            //Generate the event div recuisively
            for (var n = 0; n < pEvents.length; n++) {
                var pubEvent = pEvents[n];
                
                var eventDiv = document.createElement("div");
                htmlUtil.setClass(eventDiv, "mumEventDiv");
                
                wirePaneEventsContentDiv.appendChild(eventDiv);
                hasEventToShow = true;
                
                var title = "";
                var description = "";
                var shownType = "";
                var shownEventName = "";

                title = pubEvent.getTitle(dojo.locale);
                if (!title) {
                    title = pubEvent.getName();
                }
                
                description = pubEvent.getDescription(dojo.locale);
                if (!description) {
                    description = pubEvent.getName();
                }
                shownType = pubEvent.getPayloadType();
                shownEventName = pubEvent.getName();
                
                // To fix bug 3218 3228
                var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_SEND, [title, this.getShownType(shownType), description]);
                eventDiv.title = eventTitle;
                var widgetsArray = this.eventsMap["Send-" + shownEventName];
                var wiredEventCount = 0;
                for (var i = 0; i < widgetsArray.length; i++) {
                    wiredEventCount = wiredEventCount + widgetsArray[i].totalWiredEvents;
                }
                
                var eventDivCount = document.createElement("div");
                htmlUtil.setClass(eventDivCount, "mumEventDivCount" + this.currentType);
                
                if (wiredEventCount > 0) {
                    eventDivCount.innerHTML = wiredEventCount;
                    dojo.addClass(eventDiv, "mumEventDivWired");
                    if (wiredEventCount == 1) {
                        dojo.addClass(eventDivCount, "mumEventDivCountSingleWire" + this.currentType);
                    }
                    else {
                        dojo.addClass(eventDivCount, "mumEventDivCountMultiWire" + this.currentType);
                    }
                }
                
                var eventDivReturnImg = document.createElement("div");
                
                //defect 7491
                eventDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/green_expand.png' alt=''>";
                
                htmlUtil.setClass(eventDivReturnImg, "mumEventDivReturnImg" + this.currentType);
                this.connect(eventDivReturnImg, "onclick", this.onClickEventReturnImg);
                eventDivReturnImg.style.visibility = "hidden";
                //A11Y
                this.connect(eventDivReturnImg, "onkeypress", this.onKeyPressEventReturnImg);
                eventDivReturnImg.setAttribute("tabindex", "0");
                dojo.attr(eventDivReturnImg, "title", cws["I_WIRING_OTHER_EVENTS_" + this.currentType.toUpperCase()]);
                
                eventDiv.setAttribute("eventName", shownEventName);
                eventDiv.setAttribute("eventTitle", title);
                eventDiv.setAttribute("isClicked", "false");
                //A11Y
                eventDiv.setAttribute("tabindex", "0");
                
                eventDiv.appendChild(eventDivCount);
                
                //init the event name and payload type div
                var eventDivText1 = this.createDivWithClass("mumEventDivTextSend");
                dojo.addClass(eventDivText1, "mumEventDivText1");
                eventDivText1.title = title;
                eventDivText1.innerHTML = htmlUtil.escapeString(title);
                
                
                var eventDivText3 = this.createDivWithClass("mumEventDivTextSend");
                dojo.addClass(eventDivText3, "mumEventDivText3");
                var payloadType = this.getShownType(shownType);
                eventDivText3.title = payloadType;
                eventDivText3.innerHTML = htmlUtil.escapeString(payloadType);
                
                
                var wrapperDiv1 = document.createElement("div");
                wrapperDiv1.appendChild(eventDivText1);
                
                var wrapperDiv3 = document.createElement("div");
                wrapperDiv3.appendChild(eventDivText3);
                
                var storeEventDivInnerHTML = eventDiv.innerHTML;
                
                //construct the event content
                var eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_SEND, [wrapperDiv1.innerHTML, '<div class="mumEventDivText2">', '</div>', wrapperDiv3.innerHTML]);
                eventDiv.innerHTML = eventDiv.innerHTML + eventContent;
                
                eventDivText1 = dojo.query(".mumEventDivText1", eventDiv)[0];
                var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1, this.defaultFontStyle);
                
                eventDivText3 = dojo.query(".mumEventDivText3", eventDiv)[0];
                var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3, this.defaultFontStyle);
                
                var eventDivText2 = dojo.query(".mumEventDivText2", eventDiv)[0];
                var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2, this.italicStyle);
                eventDivText2.title = eventDivText2.innerHTML;
                
                var totalWidth = dojo.isIE ? 370 : 380;
                
                if (div1Width + div2Width + div3Width > totalWidth) {
                
                    var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
                    var widthLeftFor3 = widthLeft - div1Width;
                    var widthLeftFor1 = widthLeft - div3Width;
                    
                    if (widthLeftFor3 > 60) { //try to only truncate one only
                        div3Width = widthLeftFor3;
                        htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                    }
                    else 
                        if (widthLeftFor1 > 60) {
                            div1Width = widthLeftFor1;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                        }
                        else {
                            div1Width = widthLeft * 0.6;
                            div3Width = widthLeft * 0.4;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                            htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                        }
                }
                
                eventDiv.appendChild(eventDivReturnImg);
                
                this.connect(eventDiv, "onclick", this.onClickEvent);
                //A11Y
                this.connect(eventDiv, "onkeypress", this.onKeyPressEvent);
                this._insertEventA11yHint("Send", eventDiv, wiredEventCount);
            }
            if (!hasEventToShow) {
                wirePaneEventsContentDiv.appendChild(this.grayTip);
            }
            var wirePaneEventsBottomDiv = this.createDivWithClass("mumEventsBottomDiv" + this.currentType);
            this.wirePaneEventsDiv.appendChild(wirePaneEventsBottomDiv);
        },
        
        createCurrentWidgetDiv: function(){
        
            this.wirePaneCurrentWidgetDiv.innerHTML = "";
            var currentWidgetTitleDiv;
            htmlUtil.setClass(this.wirePaneCurrentWidgetDiv, "mumPaneDiv");
            
            var currentWidgetArrow = this.createDivWithClass("mumCurrentWidgetArrow" + this.currentType);
            
            // defect 7491
            currentWidgetArrow.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + this.currentType.toLowerCase() + (builderConfig.isBidi ? "_arrow_rtl.png' alt=''>" : "_arrow.png' alt=''>");
            
            // the mid centent of the current widget div
            var currentWidgetContentDiv = this.createDivWithClass("mumCurrentWidgetContentDiv" + this.currentType);
            var currentWidgetDiv = this.createDivWithClass("mumCurrentWidgetDiv" + this.currentType);
            
            //init the currentWidget div's content
            var currentWidgetIcon = this.createDivWithClass("mumCurrentWidgetIcon");
            currentWidgetIcon.innerHTML = "<img src='" + this.widgetObj.widgetIconSrc + "' class='mumWirePaneWidgetIcon' alt=''>";
            var currentWidgetName = this.createDivWithClass("mumCurrentWidgetName" + this.currentType);
            
            if (this.currentType == "Send") {
                currentWidgetTitleDiv = this.createDivWithClass("mumGreenTitleDiv");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_CWIDGET_SEND, currentWidgetTitleDiv, 425, this.titleFontStyle);
                dojo.attr(currentWidgetTitleDiv, "title", cws.I_WIRING_CWIDGET_SEND);
                if (this.allPubWires === 0) {
                    dojo.addClass(currentWidgetArrow, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 375, this.titleFontStyle);
                }
                else {
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 345, this.titleFontStyle);
                }
                
            }
            else {
                currentWidgetTitleDiv = this.createDivWithClass("mumBlueTitleDiv");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_CWIDGET_RECEIVE, currentWidgetTitleDiv, 425, this.titleFontStyle);
                dojo.attr(currentWidgetTitleDiv, "title", cws.I_WIRING_CWIDGET_RECEIVE);
                if (this.allHanWires === 0) {
                    dojo.addClass(currentWidgetArrow, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 375, this.titleFontStyle);
                }
                else {
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 345, this.titleFontStyle);
                }
            }
            
            currentWidgetDiv.appendChild(currentWidgetIcon);
            currentWidgetDiv.appendChild(currentWidgetName);
            currentWidgetDiv.appendChild(currentWidgetArrow);
            
            var currentWidgetBottomDiv = this.createDivWithClass("mumCurrentWidgetBottom" + this.currentType);
            currentWidgetContentDiv.appendChild(currentWidgetDiv);
            this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetTitleDiv);
            this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetContentDiv);
            this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetBottomDiv);
        },
        
        createTitleDiv: function(){
            var span = document.createElement("span");
            span.innerHTML = cws.I_WIRING_TITLE_RECEIVE;
            this.receiveTextDiv.appendChild(span);
            if (builderConfig.isBidi) {
                this.recIconDiv.innerHTML = "(" + this.allHanWires + ")";
                //defect 7491
                this.receiveWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow_deselect_rtl.png' alt=''>";
            }
            else {
                this.receiveWireCountDiv.innerHTML = "(" + this.allHanWires + ")";
                //defect 7491
                this.recIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow_deselect.png' alt=''>";
            }
            var spanSend = document.createElement("span");
            spanSend.innerHTML = cws.I_WIRING_TITLE_SEND;
            this.sendTextDiv.appendChild(spanSend);
            if (builderConfig.isBidi) {
                this.sendIconDiv.innerHTML = "(" + this.allPubWires + ")";
                //defect 7491
                this.sendWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow_rtl.png' alt='' role='presentation'>";
            }
            else {
                this.sendWireCountDiv.innerHTML = "(" + this.allPubWires + ")";
                //defect 7491
                this.sendIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow.png' alt='' role='presentation'>";
            }
            
            this.connect(this.wirePaneTitleDivLeft, "onclick", this.onClickTitlePaneLeft);
			this.connect(this.wirePaneTitleDivLeft, "onkeypress", this.onKeyPresTitlePane);
            this.connect(this.wirePaneTitleDivRight, "onclick", this.onClickTitlePaneRight);
			this.connect(this.wirePaneTitleDivRight, "onkeypress", this.onKeyPresTitlePane);
            //Set the correct Div Styles on creation
            this.adjustDivsStyle();
        },
        
        adjustTitleDiv: function(){
            htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivReceiveTab" + this.currentType);
            htmlUtil.setClass(this.leftDivOfReceiveTab, "mumLeftDivOfReceiveTab" + this.currentType);
            htmlUtil.setClass(this.midDivOfReceiveTab, "mumMidDivOfReceiveTab" + this.currentType);
            htmlUtil.setClass(this.rightDivOfReceiveTab, "mumRightDivOfReceiveTab" + this.currentType);
            if (builderConfig.isBidi) {
                htmlUtil.setClass(this.receiveWireCountDiv, "mumReceiveIconDiv" + this.currentType);
                htmlUtil.setClass(this.recIconDiv, "mumReceiveWireCountDiv");
                this.receiveWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow" + (this.currentType === "Send" ? "_deselect" : "") + "_rtl.png' alt=''>";
            }
            else {
                htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDivReceive");
                this.recIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow" + (this.currentType === "Send" ? "_deselect" : "") + ".png' alt=''>";
            }
            
            
            htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivSendTab" + this.currentType);
            htmlUtil.setClass(this.leftDivOfSendTab, "mumLeftDivOfSendTab" + this.currentType);
            htmlUtil.setClass(this.midDivOfSendTab, "mumMidDivOfSendTab" + this.currentType);
            htmlUtil.setClass(this.rightDivOfSendTab, "mumRightDivOfSendTab" + this.currentType);
            if (builderConfig.isBidi) {
                htmlUtil.setClass(this.sendWireCountDiv, "mumSendIconDiv" + this.currentType);
                htmlUtil.setClass(this.sendIconDiv, "mumSendWireCountDiv");
                this.sendWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow" + (this.currentType === "Send" ? "" : "_deselect") + "_rtl.png' alt=''>";
            }
            else {
                htmlUtil.setClass(this.sendIconDiv, "mumSendIconDivSend");
                this.sendIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow" + (this.currentType === "Send" ? "" : "_deselect") + ".png' alt=''>";
            }
        },
        
        /**
         * This function will be invoke when user click on the "wire" icon
         * 1. Gather all widget info
         * 2. Init the wire pane
         * 3. Init the Customized Dialog to show the wire pane
         */
        display: function(iwidgetId){
            this.iwidgetId = iwidgetId;
            // Default: View send events
            this.currentType = "Send";
            this.eventsMap = {};
            //Clean up the current wirepane
            if (this.wirePane) {
                this.wirePaneDiv.innerHTML = "";
                // reconstruct the UI.
                this.buildRendering();
            }
            this.widgetObj = {};
            
            //temporary - find first layoutcontrol in container
            var currentPID = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
            this.currentPageId = currentPID;
            // below is not needed when integrated 
            var tempID = com.ibm.mm.builder.utils.wireUtil.getAllLayoutControlsCSA2(currentPID);
            var layoutControl = this.getLayoutControl(this.iwidgetId);
            var icon = layoutControl.getMetaData("icon");
            if (icon === null) {
                icon = com.ibm.mm.builder.constant.generic_widget_icon;
            }
            this.widgetObj.widgetIconSrc = icon;
            this.widgetObj.widgetname = layoutControl.getTitle(ibmConfig["default.locale"]);
            
            //Init work
            this.initAllData();
            this.initWirePane();
            this.createSendEventsDiv();
            
            var contentDiv = dojo.query("." + com.ibm.mm.builder.constant.iwWidgetContent, this.iContext.getRootElement())[0];
            if (contentDiv) {
                contentDiv.appendChild(this.wirePaneDiv);
            }
            else {
                this.iContext.getRootElement().appendChild(this.wirePaneDiv);
            }
            this.displayPrompter("1");
        },
        
        setContext: function(context){
            this.iContext = context;
        },
        
        _insertA11yHint: function(domNode, hint){
            this._removeA11yHint(domNode);
			dojo.create("span", {
				innerHTML: hint,
				'class': "access"
			}, domNode, "first");
        },
        
        _removeA11yHint: function(domNode){
			dojo.query(".access", domNode).forEach(dojo.destroy);
        },
        
        _insertEventA11yHint: function(currentType, eventDiv, count){
            if (count > 0) {
				if (currentType === "Send") {
					this._insertA11yHint(eventDiv, dojo.string.substitute(cws.I_WIRING_SEND_EVENT_DESCRIPTION, [count]));
				} else {
					this._insertA11yHint(eventDiv, dojo.string.substitute(cws.I_WIRING_RECEIVE_EVENT_DESCRIPTION, [count]));
				}
            }
            else {
                this._removeA11yHint(eventDiv);
            }
        }
    });
    
})();

}
