if(!dojo._hasResource["com.ibm.mm.builder.utils.acModelUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.acModelUtil"] = true;
/**
	@author Bi Zheng(ERiK) bizheng@cn.ibm.com
*/

dojo.provide("com.ibm.mm.builder.utils.acModelUtil");

dojo.require("com.ibm.mm.builder.utils.navigationUtil");

com.ibm.mm.builder.utils.acModelUtil.VIEW = 0;

com.ibm.mm.builder.utils.acModelUtil.PERSONALIZE = 1;

com.ibm.mm.builder.utils.acModelUtil.EDIT = 2;

com.ibm.mm.builder.utils.acModelUtil.OWNER = 3;

com.ibm.mm.builder.utils.acModelUtil.getUserPermission = function(pageId) {
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var navigationNode = navigationModel.find(pageId).start(true);
	var contentNode = navigationNode.getContent().start(true);
	if(navigationNode.getMetaData("com.ibm.portal.static.page.file.name.html")) {
		if(contentNode.confirmSetStaticMarkup("")) {
			return com.ibm.mm.builder.utils.acModelUtil.EDIT;
		}
	} else {
		if(contentNode.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || 
			contentNode.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) ||
			contentNode.hasRole("Privileged User")){
				return com.ibm.mm.builder.utils.acModelUtil.EDIT;
		} 
	}
	return com.ibm.mm.builder.utils.acModelUtil.VIEW;
};

com.ibm.mm.builder.utils.acModelUtil.getPageOwner = function(pageId){
	if (!pageId) { return null; }
	
	var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId); 
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var layoutModel = navigationModel.getLayoutModel(pageId);
	var layoutNode = layoutModel.getRoot().start();
	var acModel = null;
	if (!spaceId) {
		// personal page 
		acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
	}
	else {
		var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
		var space = spaceModel.find(spaceId).start();
		acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space, layoutNode);
	}
	var pageOwner = acModel.getOwner();
	if (pageOwner) { return pageOwner; }
	return null;
};

com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner = function(spaceId){
	var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);
	var acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
	return acModel.getOwner();
};

/*
 * @deprecated, repalce with isPageOwner 
 * @param {Object} pageId
 */
com.ibm.mm.builder.utils.acModelUtil.isOwner = function(pageId){
	var pageOwner = com.ibm.mm.builder.utils.acModelUtil.getPageOwner(pageId);
	if (pageOwner) {
		var currentUserId = com.ibm.mm.builder.utils.userUtil.getCurrentUserID();
		if (pageOwner.getID() == currentUserId) { return true; }
	}
	return false;
};

com.ibm.mm.builder.utils.acModelUtil.getViewers = function(acModel){
	return com.ibm.mm.builder.utils.acModelUtil.getMemberListFromRoleModel(com.ibm.mashups.enabler.ac.RoleType.USER,acModel);
};

com.ibm.mm.builder.utils.acModelUtil.getEditors = function(acModel){
	return com.ibm.mm.builder.utils.acModelUtil.getMemberListFromRoleModel(com.ibm.mashups.enabler.ac.RoleType.EDITOR,acModel);
};

/**
 * Add the input id (user or group id)
 * memberIds:JSON object, format like 
 * {memberId:membertype} 
 * membertype can be either "user" or "group"
 */

com.ibm.mm.builder.utils.acModelUtil.addViewers = function(acModel,memberIds){
	com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType(acModel,memberIds,com.ibm.mashups.enabler.ac.RoleType.USER);
};

com.ibm.mm.builder.utils.acModelUtil.addEditors = function(acModel,memberIds){
	com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType(acModel,memberIds,com.ibm.mashups.enabler.ac.RoleType.EDITOR);
};

com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType = function(acModel, memberIds, roleType){
	if(!memberIds){
		return;
	}
    var roleModel = acModel.getRoleModel();
	var role = com.ibm.mm.builder.utils.acModelUtil.createRole(acModel, roleModel, roleType);

	if (role) {
		var memberModel = roleModel.getMemberModel(role);
		if (memberModel) {
			for (var memberId in memberIds) {
				if (Object.prototype.hasOwnProperty.call(memberIds,memberId)) {
					var newNode = memberModel.create({
						type: memberIds[memberId],
						id: memberId
					});
					memberModel.insert(newNode, null);
				}
			}
		}
	}
};

com.ibm.mm.builder.utils.acModelUtil.createRole = function(acModel, roleModel, roleType){
	roleModel.setCursorPosition(0);
	var iterator = roleModel.iterator();
	if (!iterator) { return; }
	var role = null;
	while (iterator.hasNext()) {
		role = iterator.next();
		if (!role) { continue; }
		if (role.getRoleType() == roleType) {
			return role;
		}
	}

	role = roleModel.create({ roletype: roleType });
	roleModel.insert(role, null);
    return role;
};

com.ibm.mm.builder.utils.acModelUtil.getPageAC = function(pageId){
	if (!pageId) { return null; }
	var acModel = null;
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	
	var page = navigationModel.find(pageId).start();
	var type = page.getNavigationElementType();
	if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE) {
		var layoutModel = navigationModel.getLayoutModel(pageId);
	    var layoutNode = layoutModel.getRoot().start();
		var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId); 
		if (spaceId) {
			//page in space
			var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
			var space = spaceModel.find(spaceId).start();
			acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space, layoutNode);
		}
		else {
			//page in personal space
			acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
		}
		return acModel;
	} else if (type ==  com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL) {
		return null;
	} else  {
		return null;	
	} 
};

com.ibm.mm.builder.utils.acModelUtil.getPersonalPageAC = function(pageId) {
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	navigationModel.find(pageId).start();
	var layoutModel = navigationModel.getLayoutModel(pageId);
    var layoutNode = layoutModel.getRoot().start();
    var acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
	return acModel;
};

com.ibm.mm.builder.utils.acModelUtil.getSpacePageAC = function(spaceId,pageId){
	var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
	var space = spaceModel.find(spaceId).start();
	
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	navigationModel.find(pageId).start();
	var layoutModel = navigationModel.getLayoutModel(pageId);
    var layoutNode = layoutModel.getRoot().start();
	
	return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space,layoutNode);
};

com.ibm.mm.builder.utils.acModelUtil.canEditSpace = function(spaceId){
	var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);
	var ea = com.ibm.mashups.enabler.ac.AccessFactory.getEffectiveAccess(space);
	if (ea.hasRole("editor") || ea.hasRole("manager")) {
		return true;
	}
	return false;
};


com.ibm.mm.builder.utils.acModelUtil.getSpaceAC = function(spaceId){
	if (!spaceId) {
		return null;
	}
	var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
	var space = spaceModel.find(spaceId).start();
	return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
};

com.ibm.mm.builder.utils.acModelUtil.getAllMembersInModel = function(acModel){
	var memberList = [];
	if (acModel.isInitialized()) {
		var roleModel = acModel.getRoleModel();
		roleModel.setCursorPosition(0);
		var iterator = roleModel.iterator();
		if (iterator) {
			while (iterator.hasNext()) {
				var role = iterator.next();
				if (!role) {
					continue;
				}
				var memberModel = roleModel.getMemberModel(role);
				if (!memberModel) {
					continue;
				}
				memberModel.setCursorPosition(0);
				var iterator2 = memberModel.iterator();
				if (!iterator2) {
					continue;
				}
				while (iterator2.hasNext()) {
					var member = iterator2.next();
					if (!member) {
						continue;
					}
					memberList.push(member.getEntity());
				}
			}
		}
	}
	return memberList;
};

com.ibm.mm.builder.utils.acModelUtil.getMemberListFromRoleModel = function(roleType, acModel){
	var memberList = [];
	if (acModel.isInitialized()) {
		var roleModel = acModel.getRoleModel();
		roleModel.setCursorPosition(0);
		var iterator = roleModel.iterator();
		if (!iterator) {
			return memberList;
		}
		while (iterator.hasNext()) {
			var role = iterator.next();
			if (!role || (role.getRoleType() != roleType)) {
				continue;
			}
			var memberModel = roleModel.getMemberModel(role);
			if (!memberModel) {
				continue;
			}
			memberModel.setCursorPosition(0);
			var iterator2 = memberModel.iterator();
			if (!iterator2) {
				continue;
			}
			while (iterator2.hasNext()) {
				var member = iterator2.next();
				if (!member) {
					continue;
				}
				memberList.push(member.getEntity());
			}
		}
	}
	return memberList;
};

com.ibm.mm.builder.utils.acModelUtil.removeAllMembers = function(acModel){
	com.ibm.mm.builder.utils.acModelUtil.removeViewers(acModel);
	com.ibm.mm.builder.utils.acModelUtil.removeEditors(acModel);
};

com.ibm.mm.builder.utils.acModelUtil.removeViewers = function(acModel,removeIdList){
	com.ibm.mm.builder.utils.acModelUtil.removeMembersWithRoleType(acModel,com.ibm.mashups.enabler.ac.RoleType.USER,removeIdList);
};

com.ibm.mm.builder.utils.acModelUtil.removeEditors = function(acModel,removeIdList){
	com.ibm.mm.builder.utils.acModelUtil.removeMembersWithRoleType(acModel,com.ibm.mashups.enabler.ac.RoleType.EDITOR,removeIdList);
};

com.ibm.mm.builder.utils.acModelUtil.removeMembersWithRoleType = function(acModel, roleType,removeIdList){
	var currentUserId = com.ibm.mm.builder.utils.userUtil.getCurrentUserID();
	var needRemoveAll = (arguments.length == 2);
	if(!needRemoveAll && !removeIdList){ return; }
	var roleModel = acModel.getRoleModel();
	roleModel.setCursorPosition(0);
	var iterator = roleModel.iterator();
	if (!iterator) { return; }
	while (iterator.hasNext()) {
		var role = iterator.next();
		if (!role || (role.getRoleType() != roleType)) {
			continue;
		}
		var memberModel = roleModel.getMemberModel(role);
		if (!memberModel) {
			continue;
		}
		memberModel.setCursorPosition(0);
		var iterator2 = memberModel.iterator();
		if (!iterator2) {
			continue;
		}
		while (iterator2.hasNext()) {
			var member = iterator2.next();
			if (!member) {
				continue;
			}
			var entity = member.getEntity();
			if (entity.getID() != currentUserId) {
				if (!needRemoveAll) {
					for (var id in removeIdList) {
						if ((entity.getID() == id) && (entity.getEntityType() == removeIdList[id])) {
							memberModel.remove(member);
							break;
						}
					}
				}
				else {
					memberModel.remove(member);
				}
			}
		}
	}
};

com.ibm.mm.builder.utils.acModelUtil.isPageOwner = function(pageId){
	return this.isOwner(pageId);
};

com.ibm.mm.builder.utils.acModelUtil.isSpaceOwner = function(space){
	if (!space) { return false; }
	if (!space.declaredClass) {
		space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(space);
	}
	if (space) {
		var owner = this.getSpaceOwner(space.getID());
		if (owner) {
			return owner.getID() === com.ibm.mm.builder.utils.userUtil.getCurrentUserID();
		} 
	}
	return false;
};

}
