if(!dojo._hasResource["com.ibm.mm.builder.utils.iwidgetUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.iwidgetUtil"] = true;
dojo.provide("com.ibm.mm.builder.utils.iwidgetUtil");

dojo.require("dojox.uuid.Uuid");
dojo.require("dojox.uuid.generateTimeBasedUuid");
dojo.require("com.ibm.mm.builder.constant");

com.ibm.mm.builder.utils.iwidgetUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.iwidgetUtil");

/**
 *
 * @param {Object} att iWidgetAttribute
 */
com.ibm.mm.builder.utils.iwidgetUtil.dumpItemSetsToJSON = function(att) {
    var obj = {};
    dojo.forEach(att.getAllNames(), function(name) {
        obj[name] = att.getItemValue(name);
    });
    return dojo.toJson(obj);
};

com.ibm.mm.builder.utils.iwidgetUtil.loadItemSetsFromJSON = function(att, jsonStr) {
    if (jsonStr) {
        var obj = dojo.fromJson(jsonStr);
        for (var key in obj) {
		    if(Object.prototype.hasOwnProperty.call(obj,key)) {
		    	att.setItemValue(key, obj[key], false);
			}
        }
    }
};

com.ibm.mm.builder.utils.iwidgetUtil.loadItemSetsFromJSONObject = function(att, jsonObj) {
    if (jsonObj) {
        for (var key in jsonObj) { 
		    if(Object.prototype.hasOwnProperty.call(jsonObj,key)) {
		    	att.setItemValue(key, jsonObj[key], false);
			}
        }
    }
};
/**
 * Return the widget instance icon
 * @param {String} widgetInstanceId  - this widget instance id
 */
com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceIcon = function(widgetInstanceId) {
    var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
    if (!widgetModel) {
        return com.ibm.mm.builder.constant.generic_widget_icon;
    }
    else {
        var iconValue = widgetModel.getIWidgetInstance().getIDescriptorItems().getItemValue("icon");
        var iconValue2 = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(iconValue);
        var retVal = iconValue2 || com.ibm.mm.builder.constant.generic_widget_icon;
        if (builderConfig.isBidi) {
            return this.getRtlIconUrl(retVal);
        }
        return retVal;
    }
};

/**
 * Return the widget instance title
 * @param {String} widgetInstanceId  - this widget instance id
 */
com.ibm.mm.builder.utils.iwidgetUtil.getOriginalWidgetInstanceTitle = function(widgetInstanceId) {
    var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
    if (!widgetModel) {
        return null;
    }
    var idi = widgetModel.getIWidgetInstance().getIDescriptorItems();
    return unescape(idi.getItemValue("title", dojo.locale) || idi.getItemValue("title", ibmConfig["default.locale"]));
};

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle = function(widgetInstanceId) {
    return com.ibm.mm.builder.utils.htmlUtil.escapeString(this.getOriginalWidgetInstanceTitle(widgetInstanceId));
};

/**
 * This is a helper method; It is convenient to save the widget title and title in ItemSet
 * @param {String} widgetInstanceId - this widget instance id
 * @param {String} title - the new title for this widget instance
 * @param {String} iconUrl - the url of icon
 */
com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitleAndIcon = function(widgetInstanceId, title, iconUrl) {
    this.saveWidgetInstanceTitle(widgetInstanceId, title, dojo.locale);
    this.saveWidgetInstanceIcon(widgetInstanceId, iconUrl);
};

/**
 * Save the widget instance title
 * @param {String} widgetInstanceId - this widget instance id
 * @param {String} title - the new title for this widget instance
 * @param {String} locale - the locale for this title; used in v2.0
 */
com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitle = function(widgetInstanceId, title, locale) {
    var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
    if (widgetModel) {
        // formalize locale, zh-TW 
        var separator = "-";
        var localeParts = locale.split("-");
        if (localeParts.length == 1) {
            localeParts = locale.split("_");
            separator = "_";
        }
        if (localeParts.length >= 2) {
            localeParts[1] = localeParts[1].toUpperCase();
        }
        
        var formattedLocale = "";
        for (var i = 0; i < localeParts.length; i++) {
            formattedLocale = formattedLocale + localeParts[i];
            if (i < localeParts.length - 1) {
                formattedLocale = formattedLocale + separator;
            }
        }
        
        var widgetInstance = widgetModel.getIWidgetInstance();
        var md = widgetInstance.getIDescriptorItems();
        md.setItemValue("title", escape(title), false, formattedLocale);
        com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().commit().start();
    }
};

com.ibm.mm.builder.utils.iwidgetUtil.formatWidgetTitle = function(title) {
    if (!title) {
        return '';
    }
    return title.replace(/^(&nbsp;)*/, "").replace(/</g, "&lt;").replace(/>/g, "&gt;");
};

/**
 * Save the widget instance icon
 * @param {String} widgetInstanceId - this widget instance id
 * @param {String} iconUrl
 */
com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceIcon = function(widgetInstanceId, iconUrl) {
    var widgetInstance = this.getiWidgetWrapper(widgetInstanceId);
    var md = widgetInstance.getIDescriptorItems();
    if (!iconUrl) {
        iconUrl = "/mum/images/generic_widget_icon.gif";
    }
    md.setItemValue("icon", iconUrl);
    com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().commit().start();
};

com.ibm.mm.builder.utils.iwidgetUtil.getRtlIconUrl = function(ltrIcon) {

    //returns immediately if the icon is converted to rtl already
    if (!ltrIcon || ltrIcon.match("_rtl")) {
        return ltrIcon;
    }
    var rtlIcon = ltrIcon;
    
    /*
     * getRtlIconToTest will return the RTL version of the LTR filename. For example,
     * if the LTR file is actiontimer.png, actiontimer_rtl.png will be returned.
     */
    var tmpRtlIconUrl = this.getRtlIconToTest(ltrIcon);
    try {
        var xhr = this.getXhr();
        if (xhr && tmpRtlIconUrl) {
            xhr.onreadystatechange = function() {
            };
            xhr.open("HEAD", tmpRtlIconUrl, false);
            xhr.send(null);
            /*
             * If the _rtl image file exists, its URL
             * will be assigned to rtlIcon.  The
             * below condition will be true when the HEAD
             * request returns with a success status indicating
             * that the file was found.
             */
            if (xhr.readyState == 4 && xhr.status == 200) {
                rtlIcon = tmpRtlIconUrl;
            }
        }
    } 
    catch (err) {//Quietly handle error, icon will be set to default ltr value 
    }
    return rtlIcon;
};

com.ibm.mm.builder.utils.iwidgetUtil.getRtlIconToTest = function(ltrIcon) {

    if (!ltrIcon) {
        return ltrIcon;
    }
    
    var index = ltrIcon.lastIndexOf(".");
    var filePrefix = ltrIcon.substr(0, index);
    var fileSuffix = ltrIcon.substr(index + 1);
    return filePrefix.concat("_rtl.", fileSuffix);
};

com.ibm.mm.builder.utils.iwidgetUtil.getXhr = function() {
    if (window.ActiveXObject) { // if IE
        try {
            return new ActiveXObject("Msxml2.XMLHTTP");
        } 
        catch (e) {
            try {
                return new ActiveXObject("Microsoft.XMLHTTP");
            } 
            catch (err) {
                return;
            }
        }
    }
    else if (window.XMLHttpRequest) { // if Mozilla, Safari, etc.
        return new XMLHttpRequest();
    }
};

/**
 * Save the widget instance title
 * @param {String} widgetInstanceId the container node of script elements
 */
com.ibm.mm.builder.utils.iwidgetUtil.getiWidgetWrapper = function(widgetInstanceId) {
    return com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId).getIWidgetInstance();
};

com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetIDescriptor = function(widgetInstanceId, widgetMD) {
    var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
    if (widgetModel) {
        var widgetInstance = widgetModel.getIWidgetInstance();
        var md = widgetInstance.getIDescriptorItems();
        
        var iconUrl = widgetMD.getIconURL(false);
        if (!iconUrl) {
            iconUrl = "/mum/images/generic_widget_icon.gif";
        }
        md.setItemValue("icon", iconUrl);
        
        dojo.forEach(widgetMD.getLocales(), function(l) {
            md.setItemValue("title", escape(widgetMD.getTitle(l)), false, l);
        });
        com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().commit().start();
    }
};

com.ibm.mm.builder.utils.iwidgetUtil.definitionMap = {};
com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance = function(widgetInstanceNode, widgetDefinitionId) {
    var self = com.ibm.mm.builder.utils.iwidgetUtil;
    if (widgetDefinitionId) {
        self.definitionMap[widgetInstanceNode.id] = widgetDefinitionId;
    }
    dojo.publish("/com/ibm/mashups/livetext/livetextchanged", [widgetInstanceNode, false,    // preProcessCallback
    function(domNode, tagArray) {
    },    // postProcessCallback		    
    function(domNode, tagArray, allErrors) {
        var widgetmodel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceNode.id);
        if (widgetmodel) {
            var wdid = self.definitionMap[widgetInstanceNode.id];
            if (wdid) {
                var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(wdid);
                //self.saveWidgetInstanceTitleAndIcon(widgetInstanceNode.id, com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(widgetMD), widgetMD.getIconURL());
                self.updateWidgetIDescriptor(widgetInstanceNode.id, widgetMD);
                self.definitionMap[widgetInstanceNode.id] = null;
                //com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(widgetInstanceNode.id, function(){
                //	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.autoWiringWidget", widgetInstanceNode.id);
                //});
            }
            com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(widgetInstanceNode.id);
        }
    }
]);
};

/**
 * Return the widget definition xml file url
 * @param {String} widgetId widget id
 */
com.ibm.mm.builder.utils.iwidgetUtil.getWidgetXMLURL = function(widgetId) {
    var def = dojo.query(".mm_Definition", dojo.byId(widgetId))[0];
    if (!def) {
        def = dojo.query(".iw-Definition", dojo.byId(widgetId))[0];
    }
    if (def) {
        return def.getAttribute("href");
    }
    else {
        return "";
    }
};

com.ibm.mm.builder.utils.iwidgetUtil._getUid = function() {
    return "ns_" + dojox.uuid.generateTimeBasedUuid().replace(/\-/g, "");
};

//load system widgets
com.ibm.mm.builder.utils.iwidgetUtil.loadWidgets = function(/*Dom Node*/div, /*Function*/ callback) {
    dojo.publish("/com/ibm/mashups/livetext/livetextchanged", [div, false,    // preProcessCallback
    function(domNode, tagArray) {
        //do something before loading widgets
        var widgetNumInTheme = tagArray.length;
        var widgetLoadedCount = 0;
        /*
         var cb = function(){
         widgetLoadedCount++
         if (widgetLoadedCount == widgetNumInTheme) {
         if(callback)callback();
         }
         }
         dojo.forEach(tagArray, function(tag){dojo.subscribe(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "."+tag.id, this, cb);})
         */
        var cb = function() {
            widgetLoadedCount++;
            if (widgetLoadedCount == widgetNumInTheme) {
                if (callback) {
                    callback();
                }
            }
        };
        dojo.forEach(tagArray, function(tag) {
            var lazyLoad = tag.getAttribute("lazyLoad");
            if (!lazyLoad || (lazyLoad && lazyLoad != "true")) {
                dojo.subscribe(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + tag.id, this, cb);
            }
            else {
                cb();
            }
        });
    },    // postProcessCallback
    function(domNode, tagArray, allErrors) {
    }
]);
};

com.ibm.mm.builder.utils.iwidgetUtil.toggleMarkedSandboxWidget = function(widgetDefId) {
	var tu = com.ibm.mm.builder.utils.toolboxUtil;
	var needMarkSandbox = this.isMarkedSandboxWidget(widgetDefId) ? "false" : "true";
    tu.getWidgetDefinition(widgetDefId).setMetadata("sandbox_user", needMarkSandbox);
    tu.getCatalogModel().commit().start();
	return needMarkSandbox == "true";
};

com.ibm.mm.builder.utils.iwidgetUtil.isWidgetTrusted = function (widgetDefId) {
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	var sandboxEnabled = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.SANDBOXENABLED);
	if (!sandboxEnabled) return false;
	return com.ibm.mm.builder.utils.iwidgetUtil.isTrustedWidget(widgetDefId);			
}

com.ibm.mm.builder.utils.iwidgetUtil.isMarkedSandboxWidget = function(widgetDefId) {
	return "true" == com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId).getMetadata("sandbox_user");
};

com.ibm.mm.builder.utils.iwidgetUtil.isSandboxWidget = function(widgetDefId) {
    return "true" == com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId).getMetadata("sandbox_definition");
};

com.ibm.mm.builder.utils.iwidgetUtil.isDisabledSandboxWidget = function(widgetDefId) {
    if (!this.diabledSandboxList) {
        if (dojo.isString(builderConfig.sandboxDisabled)) {
            this.diabledSandboxList = [builderConfig.sandboxDisabled];
        }
        else {
            this.diabledSandboxList = builderConfig.sandboxDisabled;
        }
    }
    if (this.diabledSandboxList.length === 0) {
        return false;
    }
    var widgetDefUrl = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId).getDefinitionURL(false);
    for (var i = 0; i < this.diabledSandboxList.length; i++) {
        if (dojo.trim(widgetDefUrl) === dojo.trim(this.diabledSandboxList[i])) {
            return true;
        }
        else if (dojo.trim(widgetDefUrl).indexOf(dojo.trim(this.diabledSandboxList[i])) !== -1 && dojo.trim(this.diabledSandboxList[i]).indexOf("/") !== 0) {//check relative path like dataEditor/dataEditor.xml
            return true;
        }
        else if (dojo.trim(widgetDefUrl).indexOf(dojo.trim(this.diabledSandboxList[i])) !== -1 && dojo.trim(this.diabledSandboxList[i]).indexOf("/") === 0 && dojo.trim(widgetDefUrl).indexOf(":") !== -1) { //check absolute path like /dataEditor/dataEditor.xml
            //make sure protocol, hostname,port match to window.location.
            var buf = widgetDefUrl.split("//");
            var protocol = buf[0];
            var buf2 = buf[1].split("/");
            var host = buf2[0];
            if (protocol == window.location.protocol && window.location.host == host) {
                return true;
            }
            else if (protocol == window.location.protocol && protocol == "http:" && host.indexOf(window.location.host) === 0) {
                if (host.substr(host.indexOf(":") + 1) == "80") {
                    return true;
                }
            }
            else if (protocol == window.location.protocol && protocol == "https:" && host.indexOf(window.location.host) === 0) {
                if (host.substr(host.indexOf(":") + 1) == "443") {
                    return true;
                }
            }
        }
    }
    return false;
};

com.ibm.mm.builder.utils.iwidgetUtil.isTrustedWidget = function(widgetDefId) {
    return this.isDisabledSandboxWidget(widgetDefId) || !(this.isSandboxWidget(widgetDefId) || this.isMarkedSandboxWidget(widgetDefId));
};
/**
 * This method will leverage subscribeEvent service to make sure the callback is invoked after the widget isntance is created
 *
 * @param {String} widgetInstanceId
 * @param {Function} callback
 */
com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId = function(/*string*/widgetInstanceId, /*function*/ callback) {
    var handler = null;
    if (!widgetInstanceId || !callback) {
        return handler;
    }
    var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
    if (wm && wm.loaded) {
        callback();
    }
    else {
        var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        handler = eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetInstanceId, null, callback);
    }
    return handler;
};

com.ibm.mm.builder.utils.iwidgetUtil.hideWidget = function(widgetId) {
    var widget = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
    if (widget) {
        widget.style.display = "none";
    }
};

com.ibm.mm.builder.utils.iwidgetUtil.showWidget = function(widgetId) {
    var widget = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
    if (widget) {
        widget.style.display = "";
    }
};

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetSpanByMetadata = function(widgetMD, itemSet) {
    var param = null;
    var widgetParam = dojo.fromJson(widgetMD.widgetParam);
    
    //store metadata to toolbox widget metadata cache for updating title/icon in skin.
    var wmdWithTitleIcon = {
        id: widgetMD.id,
        _md: widgetMD
    };
    wmdWithTitleIcon.getID = function() {
        return this._md.id;
    };
    wmdWithTitleIcon.getTitle = function(locale) {
        if (!this._md.title) {
            return null;
        }
        return this._md.title[locale];
    };
    wmdWithTitleIcon.getLocales = function() {
        if (!this._md.title) {
            return [];
        }
        if (!this.locales) {
            this.locales = [];
            for (var l in this._md.title) {
                if (Object.prototype.hasOwnProperty.call(this._md.title, l)) {
                    this.locales.push(l);
                }
            }
        }
        return this.locales;
    };
    wmdWithTitleIcon.getIconURL = function() {
        return this._md.icon;
    };
    com.ibm.mm.builder.utils.toolboxUtil.setWidgetDefinition(wmdWithTitleIcon);
    
    if (widgetParam && widgetParam.length) {
        param = com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
        dojo.forEach(widgetParam, function(item) {
            com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, item.itemName, item.itemValue);
        });
    }
    
    if (itemSet) {
        param = param || com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
        for (var key in itemSet) {
        	if (Object.prototype.hasOwnProperty.call(itemSet, key)) {
				var ii = dojo.query("[href='#" + key + "']", param);
				if (ii && ii[0]) {
					ii[0].innerHTML = itemSet[key];
				}
				else {
					com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, key, itemSet[key]);
				}
			}
        }
    }
    
    var rootSpan = document.createElement("span");
    
    // OpenSocial support change
    if (this.widgetType !== null && this.widgetType == "mm_OAGadget") {
        dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmOAGadget);
    }
    else {
        if (this.widgetType !== null && this.widgetType == "mm_OSGadget") {
            dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmGGadget);
        }
        else {
            dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmIWidget);
        }
    }
    
    rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_id, "" + this._getUid());
    var layoutBean = com.ibm.mm.builder.freeLayOutBean || com.ibm.mm.builder.columnLayoutBean;
    if (layoutBean) {
        rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, layoutBean.getSelectedSkin());
    }
    com.ibm.mm.builder.utils.iWidgetSpecUtil.setWidgetDefXML(rootSpan, widgetMD.definition);
    
    if (com.ibm.mm.builder.widget.sandboxEnabled) {
        if (widgetMD.sandbox_definition === "true" || widgetMD.sandbox_user === "true") {
            rootSpan.setAttribute("sandbox", "true");
        }
    }
    
    if (widgetMD['com.ibm.mashups.builder.autoWiringEnabled'] === "true") {
        rootSpan.setAttribute("autowiringenabled", "true");
    }
    if (param) {
        rootSpan.appendChild(param);
    }
    return rootSpan;
};

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetSupportedModes = function(widgetId) {
    var modes = null;
    var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
    if (widgetWrapper) {
        var getSMDeferred = widgetWrapper.getIWidgetDefinition();
        getSMDeferred.setFinishedCallback(function(widgetDef, status) {
            if (widgetDef) {
                modes = widgetDef.getSupportedModes();
            }
        });
        getSMDeferred.start(false);
    }
    return modes;
};

com.ibm.mm.builder.utils.iwidgetUtil.isWidgetVisible = function(widgetId) {
    var widgetSpan = dojo.byId(widgetId);
    if (widgetSpan) {
        return widgetSpan.getAttribute("visible") ? eval(widgetSpan.getAttribute("visible")) : false; // JSLINT-IGNORE:
    }
    return false;
};

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2 = function(lcId) {
    var layoutControl = com.ibm.mm.builder.utils.iwidgetUtil.getLayoutControl(lcId);
    var lc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
    var prefLoc = lc.getPreferredLocale();
    var title = layoutControl.getTitle(prefLoc);
    if (!title) {
        var wm = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
        var widgetWin = wm.getWidgetWindow(layoutControl).start();
        if (widgetWin) {
            var widgetDef = wm.getWidgetDefinitionByWindow(widgetWin).start();
            if (widgetDef) {
                title = com.ibm.mashups.enabler.context.Factory.getLocalizedContext().getTitle(widgetDef);
            }
        }
    }
    return title || "";
};

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetIconCSA2 = function(lcId) {
	var lc = com.ibm.mm.builder.utils.iwidgetUtil.getLayoutControl(lcId);
	var icon = lc.getMetaData("thumbnail") || lc.getMetaData("icon");
    if (!icon) {
        return com.ibm.mm.builder.constant.generic_widget_icon;
    } else {
		return icon;
	}
};

com.ibm.mm.builder.utils.iwidgetUtil.getLayoutControl = function(lcId) {
	var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	var currentPage = navModel.find(pageId).start();
	var layoutModel = navModel.getLayoutModel(currentPage);
	var layoutControl = layoutModel.find(lcId).start();
	return layoutControl;
};


}
