if(!dojo._hasResource["com.ibm.mm.builder.utils.skinUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.skinUtil"] = true;
/**
 * Util class for skin
 */
dojo.provide("com.ibm.mm.builder.utils.skinUtil");
dojo.require("com.ibm.mm.builder.SkinHelper");

com.ibm.mm.builder.utils.skinUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.skinUtil");

com.ibm.mm.builder.utils.skinUtil.getSkinNode = function(skinId){
	var skinModel = com.ibm.mm.builder.utils.skinUtil._getSkinModel();
	if (skinModel !== null){
		return skinModel.find(skinId).start();
    }
    com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getSkinNode", com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
    return null;
};

com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId = function(){
	var curThemeId = com.ibm.mm.builder.utils.themeUtil.getCurrentThemeId();
	if (curThemeId){
	    var themeModel = com.ibm.mm.builder.utils.themeUtil.getThemeModel(true); 
	    var theme = com.ibm.mm.builder.utils.themeUtil.getThemeNode(curThemeId);
	    if (theme !== null) {
			return theme.getDefaultSkin();
		} else {
			com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getDefaultSkinId", com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
			return null;
		}		
	}
	return null;
};

com.ibm.mm.builder.utils.skinUtil.getDefaultSkin = function(){
	var defaultSkinId = com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId();
	if (defaultSkinId){
		return com.ibm.mm.builder.utils.skinUtil.getSkinNode(defaultSkinId);
	}else{
		return com.ibm.mm.builder.utils.skinUtil.getFirstSkinNode();
	}
};

com.ibm.mm.builder.utils.skinUtil.getFirstSkinNode = function(){
	var skinModel = com.ibm.mm.builder.utils.skinUtil._getSkinModel();
	if (skinModel !== null){
		var iterator = skinModel.iterator(); 
        if (iterator.hasNext()) {
            var skin = iterator.next();
            var title = skin.getTitle("en");
            if ((title) && (skin.getMetaData("com.ibm.mashups.builder.skin.nva"))) {
                skin = iterator.next();
            }
            return skin;
        }
	}
	com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getFirstSkinNode",com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
	return null;
};

com.ibm.mm.builder.utils.skinUtil.getNVANode = function(){
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
	var nvaSkin = null;
	dojo.forEach(skins, function(skin){
		var title = skin.getTitle("en");
        if ((title) && (skin.getMetaData("com.ibm.mashups.builder.skin.nva"))) {
			nvaSkin = skin;
        }
    });
	if (nvaSkin){
		return nvaSkin;
	}else{
		com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getNVANode",com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
		return null;		
	}
};

com.ibm.mm.builder.utils.skinUtil._getSkinModel = function(){
    var curThemeId = com.ibm.mm.builder.utils.themeUtil.getCurrentThemeId();
    var themeModel = com.ibm.mm.builder.utils.themeUtil.getThemeModel(); 
    var theme = com.ibm.mm.builder.utils.themeUtil.getThemeNode(curThemeId);
    if (theme!==null){
		if (!this.skinModel){
        	this.skinModel = themeModel.getSkinModel(theme);
        	this.skinModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(10));
		}
		return this.skinModel;
    }
    return null;
};

/**
 * create editbar for widget
 */
com.ibm.mm.builder.utils.skinUtil.getEditBarNode = function(args,layoutContext){
	/*<div id="${widgetId}_dragHandler_editbar" style="display:none" class="editBar" onmouseover="javascript:com.ibm.mm.builder.skinHelper.setEditBarOpaque('${widgetId}_dragHandler_editbar')" >
		<div id="${widgetId}_dragHandler" class="dojoDndHandle borderinHM">
			<div class="widgetDragHandlerMiddle">
				<img src="${iconUrl}"  class="widgetIconStyle">
				<span class="widgetTitleShadow" >${title}</span>
				<span class="widgetTitle" >${title}</span>
				<img src="/mum/images/interactions_icon.png" class="widgetInteraction" title="Click to wire widgets" border=0>
				<img id="${menuId}" src="/mum/images/context_menu.png" class="widgetContext" title="Click to open menu of options" onclick="javascript:com.ibm.mm.builder.skinHelper.createMenu(event,'${menuId}','${widgetId}')" border=0>	
			</div>	
			<div class="widgetDragHandlerLeft"></div>
			<div class="widgetDragHandlerRight"></div>
		</div>
		<div class="widgetDragHandlerBG"></div>
		<div class="widgetDragHandlerCorner"></div>
		<div class="editBarRightTopCornerShadow"></div>	
		<div class="editBarCornerShadow"></div>
	</div>*/
	var editBar = document.createElement("div");
	dojo.addClass(editBar,"editBar");
	editBar.id = args.widgetId + com.ibm.mm.builder.constant.editbarDragHandler;
	editBar.style.display = "none";
	dojo.connect(editBar,"onmouseover", null, function(){com.ibm.mm.builder.skinHelper.setEditBarOpaque(args.widgetId + com.ibm.mm.builder.constant.editbarDragHandler);});
	
	var widgetDragHandler = document.createElement("div");
	widgetDragHandler.id = args.widgetId + '_dragHandler';
	dojo.addClass(widgetDragHandler,"dojoDndHandle");
	dojo.addClass(widgetDragHandler,"borderinHM");
	var widgetDragHandlerMiddle = document.createElement("div");
	dojo.addClass(widgetDragHandlerMiddle,"widgetDragHandlerMiddle");
	
	var widgetIcon = document.createElement("img");
	//Fix bug 2854 [Performance Defect]Too many resources are downloaded during login.
	//comment out this line will help to reduce one http request for each widget in the page
	//widgetIcon.src= args.iconUrl;
	dojo.addClass(widgetIcon,"widgetIconStyle");
	
	var widgetTitleShadow = document.createElement("span");
	widgetTitleShadow.innerHTML= args.title;
	dojo.addClass(widgetTitleShadow,"widgetTitleShadow");
	
	var widgetTitle = document.createElement("span");
	widgetTitle.innerHTML= args.title;
	dojo.addClass(widgetTitle,"widgetTitle");
	
	if(dojo.isSafari || dojo.isIE){
		widgetTitleShadow.style.width = "75%";
		widgetTitle.style.width = "75%";
	}
	
	var wiringIcon = document.createElement("input");		 
	wiringIcon.alt = wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_WIRE_ICON_TITLE;			
	dojo.addClass(wiringIcon,"widgetInteraction");
	
	dojo.attr(wiringIcon,"type","image");
	if (builderConfig.isBidi) {
		dojo.attr(wiringIcon,"src",builderConfig.builderPath + "/images/d_wiring_icon_rtl.png");	
	}
	else {
		dojo.attr(wiringIcon,"src",builderConfig.builderPath + "/images/d_wiring_icon.png");	
	}
	dojo.connect(wiringIcon,"onclick", null,  function(){
		com.ibm.mm.builder.skinHelper.launchWiring(args.widgetId);
	});
	
	// fix dnd issue when click the icon
	dojo.connect(wiringIcon,"onmousedown",null,function(evt) {dojo.stopEvent(evt);});
	
	var menuIcon = document.createElement("input");
	menuIcon.id= args.widgetId + "_menu";				
	menuIcon.alt = menuIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_EDIT_ICON_TITLE;
	dojo.addClass(menuIcon,"widgetContext");
	dojo.attr(menuIcon,"type","image");
	if (builderConfig.isBidi) {
		dojo.attr(menuIcon,"src",builderConfig.builderPath + "/images/context_menu_rtl.png");	
	}
	else {
		dojo.attr(menuIcon,"src",builderConfig.builderPath + "/images/context_menu.png");
	}
	
	dojo.connect(menuIcon, "onclick", null, function(event){com.ibm.mm.builder.skinHelper.createMenu(event,args.widgetId+"_menu",args.widgetId,false,layoutContext);});
	// fix dnd issue when click the icon
	dojo.connect(menuIcon,"onmousedown",null, function(evt) {dojo.stopEvent(evt);});
	
	widgetDragHandlerMiddle.appendChild(widgetIcon);
	widgetDragHandlerMiddle.appendChild(widgetTitleShadow);
	widgetDragHandlerMiddle.appendChild(widgetTitle);
	widgetDragHandlerMiddle.appendChild(wiringIcon);
	widgetDragHandlerMiddle.appendChild(menuIcon);
	
	var widgetDragHandlerLeft = document.createElement("div");
	var widgetDragHandlerRight = document.createElement("div");
	
	if (builderConfig.isBidi) {
		dojo.addClass(widgetDragHandlerLeft,"widgetDragHandlerLeftRtl");
		dojo.addClass(widgetDragHandlerRight,"widgetDragHandlerRightRtl");
	}
	else {
		dojo.addClass(widgetDragHandlerLeft,"widgetDragHandlerLeft");
		dojo.addClass(widgetDragHandlerRight,"widgetDragHandlerRight");
	}
	
	widgetDragHandler.appendChild(widgetDragHandlerLeft);
	widgetDragHandler.appendChild(widgetDragHandlerRight);
	widgetDragHandler.appendChild(widgetDragHandlerMiddle);
	
	var widgetDragHandlerBG = document.createElement("div");
	dojo.addClass(widgetDragHandlerBG,"widgetDragHandlerBG");
	
	var widgetDragHandlerCorner = document.createElement("div");
	dojo.addClass(widgetDragHandlerCorner,"widgetDragHandlerCorner");
	
	var editBarRightTopCornerShadow = document.createElement("div");
	dojo.addClass(editBarRightTopCornerShadow,"editBarRightTopCornerShadow");
	
	var editBarCornerShadow = document.createElement("div");
	dojo.addClass(editBarCornerShadow,"editBarCornerShadow");
	
	editBar.appendChild(widgetDragHandler);
	editBar.appendChild(widgetDragHandlerBG);
	editBar.appendChild(widgetDragHandlerCorner);
	editBar.appendChild(editBarRightTopCornerShadow);
	editBar.appendChild(editBarCornerShadow);
	
	return editBar;
};
	
/**
 *  parse the width,height.. from the locationStyle string
 *  @param locationStyle should be "position:absolute;width:300px;height:400px;left:20px;top:400px;z-Index:40;"
 */
com.ibm.mm.builder.utils.skinUtil.getValueFromStyle = function(key,locationStyle){
	if (locationStyle.indexOf(key)==-1){return null;}
	var pos = locationStyle.indexOf(key);
	var substr1 = locationStyle.substr(pos,locationStyle.length);
	var startPos = substr1.indexOf(":");
	var endPos = substr1.indexOf(";");
	var value = substr1.substr(startPos + 1,endPos - startPos);
	return value;
};

com.ibm.mm.builder.utils.skinUtil.setValueToStyle = function(locationStyle,key,value){
	if (locationStyle.indexOf(key)==-1){return null;}
	var pos = locationStyle.indexOf(key);
	var left = locationStyle.substr(0,pos + key.length + 1);
	var draftRight = locationStyle.substr(pos + key.length + 1,locationStyle.length);
	var right = draftRight.substr(draftRight.indexOf(";"),draftRight.length);
	var newStyle = left + value + right;
	return newStyle;
};

com.ibm.mm.builder.utils.skinUtil.updateDefaultSize = function(widgetId){

	var controlId = widgetId;

	var publishWidgetSize = function(){

		var wrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
		var defaultHeight = wrapper.getIDescriptorItems().getItemValue("defaultHeight");
		var defaultWidth = wrapper.getIDescriptorItems().getItemValue("defaultWidth");
		var payload = null;
		if (defaultHeight && defaultWidth) {
	            payload = {"newWidth": defaultWidth,"newHeight": defaultHeight};
		}
		else {
			if (defaultHeight) {
		            payload = {"newHeight": defaultHeight};
			}
			if (defaultWidth) {
		            payload = {"newWidth": defaultWidth};
			}
		}
			
		if (payload){

			var rsModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
			var widgetSkinNode = rsModel.find(widgetId);

			// save the new control size in the NavState
		      var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
			var accessorFactory = com.ibm.mashups.enabler.model.state.AccessorFactory;
			var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, controlId);
			widgetAccessor.setSize(defaultWidth, defaultHeight);
			navStateModel.commit().start();

			// save the new style to the runtime skin model 
			var style = widgetSkinNode.getStyle();
			var changes = {};
			changes.height = defaultHeight + "px";
			changes.width  = defaultWidth + "px";
			widgetSkinNode.setStyle(dojo.mixin(style, changes));

			// update the UI
			var div = com.ibm.pb.layout.LayoutParser.findById(controlId);
   			if (div) {
				var widgetBody = dojo.query(".lotusWidgetBody", div)[0];
   				if (widgetBody) {
					if (defaultHeight) {
						dojo.style(widgetBody, "height", defaultHeight + "px");
					}
					var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			     		eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + widgetId, payload);
					eventService.publishEvent("com.ibm.mashups.builder.resizeWidget", payload);  // needed for freeform layout
   				}
   			}
   		}  
	}; 

    	var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
    	if (wm && wm.loaded) {
     		publishWidgetSize();
    	} else {
    		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
    	  	loadedHandler = eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetId, null, publishWidgetSize);
      }
};

	
/**
 *  set mouseout handler of widget for hiding editbar
 */	
com.ibm.mm.builder.utils.skinUtil._widgetOnMouseOut = function(iwidgetId){
	dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix+iwidgetId).onmouseout=function(){com.ibm.mm.builder.skinHelper.hideEditBar(iwidgetId+com.ibm.mm.builder.constant.editbarDragHandler);};
	com.ibm.mm.builder.skinHelper.hideEditBar(iwidgetId+com.ibm.mm.builder.constant.editbarDragHandler);
};

/**
 * update the title and/or icon of the widget instance
 * @param {String} widgetInstanceId
 */
com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon = function(widgetInstanceId){
	var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
	var _title = widgetUtil.getWidgetInstanceTitle(widgetInstanceId);
	var title = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(_title);
	var icon = widgetUtil.getWidgetInstanceIcon(widgetInstanceId);
	try{
        dojo.attr(dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix+widgetInstanceId),"aria-label",_title);
    }catch(error){
		// skins resources are loaded with widget resources w/ multipart
        if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartEnabled()) {
            return;
        }
        throw error;
    }
	// if visible == false, the widget instance is in NVA
	// if visible == true, the widget instance is in VA
	var visible = dojo.byId(widgetInstanceId).getAttribute("visible");
	if (visible == "false") {
		var iconDiv = dojo.byId(widgetInstanceId + "_icon");
		if (iconDiv) {
			iconDiv.src = icon;
			iconDiv.alt="";
		}
		// concat the display title if it is too long
		var titleNode = dojo.byId(widgetInstanceId + "_name_middle");
		titleNode.innerHTML = _title;
		titleNode.title = _title;
		
		//for a11y
		if (iconDiv) {
			iconDiv.alt = titleNode.textContent;
		}

		dojo.attr(titleNode,"widthLimit","210");
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(titleNode,null,{fontSize:"1.2em",fontWeight:"bold"});
	} else {
		//update title and icon in skin
		var titleContent = document.getElementById(widgetInstanceId + "_title_content");
		var iconContent = document.getElementById(widgetInstanceId + "_icon");
		if (titleContent) {
			titleContent.innerHTML = title;
		}
		if (iconContent) {
			iconContent.src = icon;
			iconContent.alt = "";
		}
		//update icon and title in edit bar
		var editbar = dojo.byId(widgetInstanceId + "_dragHandler");
		if(editbar) {
			var titleSpan = dojo.query(".widgetTitle", editbar)[0];
			var styleWidth = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(editbar.parentNode.parentNode,"width");
			var width = parseInt(parseInt(styleWidth.replace(/px/,""),10)*0.55-120,10);
			if(titleSpan) {
				dojo.attr(titleSpan,"widthLimit",width);
				titleSpan.innerHTML = _title;
				titleSpan.title = _title;
				com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(titleSpan);
			}
			var titleShadowSpan = dojo.query(".widgetTitleShadow", editbar)[0];		
			if(titleShadowSpan) {
				dojo.attr(titleShadowSpan,"widthLimit",width);
				titleShadowSpan.innerHTML = _title;
				titleShadowSpan.title = _title;
				com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(titleShadowSpan);
			}
			var iconImag = dojo.query(".widgetIconStyle", editbar)[0];
			if(iconImag){ 
				iconImag.src = icon;
				iconImag.alt = "";
			}
		}
	}
};

com.ibm.mm.builder.utils.skinUtil.skinMinSize = {
	"Default":76
};

com.ibm.mm.builder.utils.skinUtil.getMinSize = function(skin){
	if (typeof com.ibm.mm.builder.utils.skinUtil.skinMinSize[skin] != 'undefined') {
		return com.ibm.mm.builder.utils.skinUtil.skinMinSize[skin];
	} else {
		return com.ibm.mm.builder.utils.skinUtil.skinMinSize.Default;
	}
};

/*
 * get the skinNode's location information
 */
com.ibm.mm.builder.utils.skinUtil.getLocationValue = function(key, widgetId){
	var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	return dojo.style(widgetSkinNode,key);
};

com.ibm.mm.builder.utils.skinUtil.setLocationValue = function(key,value,widgetId){
	var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	dojo.style(widgetSkinNode,{key:value});
};

com.ibm.mm.builder.utils.skinUtil.markIWidgetInstanceAsDraggable = function(wdigetInstanceId){
	var skinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + wdigetInstanceId);
	skinNode.setAttribute("dndtype", "iWidgetInstance");
	skinNode.setAttribute("dnddata", wdigetInstanceId);
	dojo.addClass(skinNode,"dojoDndItem");
};

com.ibm.mm.builder.utils.skinUtil.skins = null;

com.ibm.mm.builder.utils.skinUtil.getAllSkins = function(){
	if(com.ibm.mm.builder.utils.skinUtil.skins &&
           (0 < com.ibm.mm.builder.utils.skinUtil.skins.length)){
		return com.ibm.mm.builder.utils.skinUtil.skins;   	
	}
	com.ibm.mm.builder.utils.skinUtil.skins = [];
	var skinModel = com.ibm.mm.builder.utils.skinUtil._getSkinModel();
    if (skinModel !== null) {
        var iterator = skinModel.iterator();
        while (iterator.hasNext()) {
            com.ibm.mm.builder.utils.skinUtil.skins.push(iterator.next());
        }
    }
	return com.ibm.mm.builder.utils.skinUtil.skins;
};

}
