dojo.provide("com.ibm.pb.dnd.layout.LayoutRowSource");

dojo.require("com.ibm.pb.dnd.layout.LayoutSource");

dojo.declare("com.ibm.pb.dnd.layout.LayoutRowSource", [com.ibm.pb.dnd.layout.LayoutSource], {
	ghostClass: "ibmDndHorizontalGhost",
	currentHolder: null, // this holds the current target when the ghost is inserted before a source
	onDrop: function(source, nodes, copy){
		this.LOGGER.entering("onDrop",[source, nodes, copy]);
		
		//this.firstInsert is used to flag whether the widget will be inserted in the first place of the un-empty row 
		/*
		if(!this.current && !this.emptyContainer && !this.firstInsert){
			this.onDndCancel();
			return;
		}
		*/
						
		// A row source can have an active target without a current target
		// active in the dojo framework. currentHolder will hold the target 
		// to determine where to drop when this scenario occurs
		if(!this.current && this.currentHolder && !this.emptyContainer){
			this.current = this.currentHolder;		
			this.before = true; 
		}
		
		var currentNode = dojo.byId(nodes[0].id);
		var sourceItem = source.getItem(currentNode.id);
		var type = sourceItem ? sourceItem.type : null;
		if(sourceItem && (type == ibmCfg.controllers.dnd.SHELF_TYPE)){
			this.onDropFromShelf(source, nodes, copy);
		}else{
			if(this != source){
				this.onDropExternal(source, nodes, copy);
			}else{
				this.onDropInternal(nodes, copy);
			}
		}
		var currentContainer = null;
		if(this.current){
			currentContainer = this.current.parentNode;
		}else{
			currentContainer = this.emptyContainer;
		}
		
		if (!currentContainer) {
			currentContainer = dojo.dnd.manager().target.node;
		}
		
		if (!currentContainer) {
			currentContainer = currentNode.parentNode;
		}
		
		this._calculateDropTarget(currentNode, currentContainer, type);
		
		this._processDrop(currentNode, currentContainer, source, nodes, copy);
		
		dojo.style(currentNode,{cursor:"default",opacity: 1,display: ""});
		
		this.LOGGER.exiting("onDrop",[source, nodes, copy]);
	},
	onDndCancel: function(){
		if (this.isDragging) {
			this.inherited(arguments);			
			this.removeGhost();	
		}
	},
	onOverEvent: function(){
		// create ghost in empty container
		this.inherited(arguments);
		this.active = true;
		
		if(this.isDragging && dojo.dnd.manager().target){
			var currentContainer = dojo.dnd.manager().target.node;	
			var controls = dojo.query('.'+ibmCfg.controllers.dnd.CONTROL_CLASS, currentContainer);	
			
			this.emptyContainer = currentContainer;
			if(dojo.query("."+this.ghostClass).length == 0 ){
					// creating ghosts in empty layout container
					this.emptyContainer.appendChild(this.createEmptyContainerGhostMarkup());
				}
			if(controls.length != 0){	
				this.emptyContainer = null;
			}
			
			/*
			// check to see if layout container is empty
			if(controls.length == 0){			
				this.emptyContainer = currentContainer;
				if(dojo.query("."+this.ghostClass).length == 0 ){
					// creating ghosts in empty layout container
					this.emptyContainer.appendChild(this.createEmptyContainerGhostMarkup());
				}
			}else{
			// clear the empty layout container object
				this.emptyContainer = null;			
			}
			*/
		}
	},
	onOutEvent: function(){
		// remove ghost from empty container
		this.inherited(arguments);
		this.active = false;
		
		if((dojo.query("."+this.ghostClass).length > 0) && !this.current){
			this.removeGhost();
		}
	},	
	_markTargetAnchor: function(before){
		// determines when to create the ghost, before or after the target
		if(this.current == this.targetAnchor && this.before == before){ return; }
		if((this.targetAnchor != this.current) && !this.targetSelected){
			this.currentHolder = null;
			this.removeGhost(this.targetAnchor);
		}
		if (this.current == null && this.targetAnchor != null) {
			this.current = this.targetAnchor;
		}else if (this.targetAnchor == null && this.current != null){
			this.targetAnchor = this.current;
		}else{
			this.targetAnchor = this.current;
		}
		this.targetBox = null;
		this.before = before;
		if(this.targetAnchor){
			this.currentHolder = this.current;
			this.createGhost(this.targetAnchor, this.before ? "Before" : "After");
			if(this.before){
				this.firstInsert = true;
			}
		}else{
			this.firstInsert = false;
		}
	},
	_unmarkTargetAnchor: function(){
		// determines when to remove the ghost
		if(!this.targetAnchor && !this.targetSelected){ return; }
		this.removeGhost(this.targetAnchor);
		this.currentHolder = null;
		this.targetAnchor = null;
		this.targetBox = null;
		this.before = true;
	},
	_addItemClass: function(node, type){
		// create ghost
		if(this.current == node && this.before == type){ return; }
		if(this.isDragging){
			this.createGhost(node, type);
		}
	},
	_removeItemClass: function(node, type){
		// remove ghost
		if(this.isDragging){
			this.removeGhost();
		}
	},
	createGhost: function(node, type){	
		// creates ghost on page
		if(type == "Before"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node);
		}else if (type == "After"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node.nextSibling);
		}
	},
	removeGhost: function(){
		// removes ghost from page
		var ghost = dojo.byId(this.ghostClass);
		if(ghost){
			var parent = ghost.parentNode;
			parent.removeChild(ghost);
		}
	},
	createGhostMarkup: function(){
		// check to see if a ghost is already on the page
		// and remove before creating another
		this.removeGhost();
		var elem = document.createElement("div");
		dojo.attr(elem, {
				className: this.ghostClass,
				id: this.ghostClass,
		        onmouseover: dojo.hitch(this, function(e){	if (!e) var e = window.event; 
															if(dojo.isIE){ this.targetSelected=e.srcElement; }
															else{ this.targetSelected = e.currentTarget; }
											  }
										),
				onmouseout: dojo.hitch(this, function(){ this.targetSelected = null })
			});
		return elem;
	},
	createEmptyContainerGhostMarkup: function(){
		var elem = document.createElement("div");
		elem.className = this.ghostClass;
		elem.id = this.ghostClass;
		return elem;
	}
});

com.ibm.pb.dnd.layout.LayoutRowSource.creator = function(item, hint){
		if(hint=="avatar"){
			var node = dojo.doc.createElement("div");
			if(dojo.dnd.manager().source.current){
				// use the portlet markup as avatar
				node.innerHTML = String(item);
				var elem = dojo.byId(dojo.dnd.manager().source.current.id);
				dojo.style(node, { width: elem.offsetWidth+"px", opacity: 0.5});
			}
			return {node: node, data: item, type: [ibmCfg.controllers.dnd.DND_TYPE]};
		} else {  // this works the same way as the _normalizedCreator/onDropExternal functions in dojo.dnd.Source when there is no given creator function
			if(dojo.isOpera) {
				var node = dojo.byId(ibmCfg.controllers.dnd.currentNode.id).parentNode;  // opera returned nothing using dojo.query below
			} else {
				var node = dojo.query("[id~="+ibmCfg.controllers.dnd.currentNode.id+"]")[0];
			}
			if(node){
				var source = ibmCfg.controllers.dnd.dndSources[com.ibm.pb.layout.LayoutParser.extractID(node.parentNode)];
				if(source){
					var t = source.getItem(node.id);
					source.delItem(node.id);
					source.selection = {};  // prevents node from being deleted in dojo.dnd.Selector.deleteSelectedNodes called by onDropExternal()
					return {node: node, data: t.data, type: t.type};
				}
			} 
			return {node:dojo.create("div"),data:item,type:ibmCfg.controllers.dnd.DND_TYPE}
		}
};

com.ibm.pb.dnd.layout.LayoutRowSource.withHandles = true;
