<%@include file="include/bootfuncs.jsp" %>
<%
    final com.ibm.mm.framework.services.IConfigService configService = com.ibm.mm.framework.Platform.getInstance().getConfigService();

    // first let's see if we have a mymashups available, then fallback to root, and finally fallback to /mum
    String enablerContext = configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MYMASHUPS, configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MAIN, "/mum"));
       
    final String realEnablerContext = configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MAIN, "/mum");
    
    // look for the servlet path
    final String servletPathHome = configService.getString(com.ibm.mm.ConfigConstants.SERVLET_PATH_MASHUPS_HOME, "/enabler");
    
    final String publicHome = enablerContext+servletPathHome;
    
    final String privateContentHandler = configService.getString(com.ibm.mm.ConfigConstants.CONTENTHANDLER_PRIVATE,"/mycontenthandler");

    final boolean isErrorScreen = request.getParameter("fail") != null;
    
    final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("resources.bootstrap", com.ibm.mm.framework.rest.next.LocaleUtil.getPreferredLocale(request));
    
    final String availableLocales = join(configService.getStrings(com.ibm.mm.ConfigConstants.AVAILABLE_LOCALES),",");

    final String currentLocale	 =  com.ibm.mm.framework.rest.next.LocaleUtil.getPreferredLocale(request).toString(); 	 
   
    final String isBidi	=  isBidi(currentLocale);
    
    final String isDebug	    		= configService.getString(com.ibm.mm.ConfigConstants.CLIENT_IS_DEBUG);    
    
    final String rtlClass = "1".equals(isBidi) ? "mumrtl" : "";
    
    String dojoVersion = configService.getString(com.ibm.mm.ConfigConstants.DOJO_VERSION);
    String blueDojo = "/js/bluedojo";
    if ((null != dojoVersion) && !("".equals(dojoVersion))){
        dojoVersion = "/" + dojoVersion;
        blueDojo = blueDojo + dojoVersion;
    }
    String dojoRoot = enablerContext + blueDojo;
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="en">
<head>
    <title><%=configService.getString(com.ibm.mm.ConfigConstants.PRODUCT_NAME)%></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <%@include file="include/share.js.jsp" %>
    <link rel="shortcut icon" href="/mum/images/favicon.ico" type="image/x-icon"/>
    <link rel="icon" href="/mum/images/favicon.ico" type="image/x-icon"/>
    <%--
     seems as if this has been removed lately
    <link rel="stylesheet" href="/mum/_combined.css" type="text/css"/>
    --%>
    <script language="JavaScript" type="text/javascript">
	
	function adjustToFrame() {
        try {
            var myLocation = document.location + "";
            
            // check if login is shown in the embedding usecase
            if (window.parent.length >= 1) {
                // search for height & width:
                var pos1;
                var pos2;
                
                pos1 = myLocation.indexOf("&sb=");
                if (pos1 > -1) {
                    pos1 += 4;
                    pos2 = myLocation.indexOf("&", pos1);
                    
                    var scrollbarEnabled;
                    
                    if (pos2 > -1)
                        scrollbarEnabled = myLocation.substring(pos1, pos2);
                    else
                        scrollbarEnabled = myLocation.substring(pos1);
                        
                    
                    if (scrollbarEnabled == "yes")
                        return;
                }
                
                var myHeight = 0;
                
                pos1 = myLocation.indexOf("&h=");
                
                if (pos1 >-1) {
                    pos1 += 3;
                    pos2 = myLocation.indexOf("&", pos1);
                    if (pos2 > -1)
                        myHeight = myLocation.substring(pos1, pos2);
                    else
                        myHeight = myLocation.substring(pos1);
                }
                
                var myWidth = 0;
                
                pos1 = myLocation.indexOf("&w=");
                
                if (pos1 >-1) {
                    pos1 += 3;
                    pos2 = myLocation.indexOf("&", pos1);

                    if (pos2 > -1)
                        myWidth = myLocation.substring(pos1, pos2);
                    else
                        myWidth = myLocation.substring(pos1);
                }
                
                
                if (myWidth > 0 && myHeight >0) {
                    var contentDiv = document.getElementById("contentDiv");
                    contentDiv.style.width=myWidth + "px";
                    contentDiv.style.height=myHeight + "px";
                    contentDiv.style.overflow="auto";
                    
                    contentDiv = document.getElementById("innerContentDiv");
                    contentDiv.style.width=parseInt(myWidth)+1 + "px";
                    contentDiv.style.height=parseInt(myHeight)+1 + "px";
                }
            }
        } catch (e) {
        }
    }
	
    window.onload = function() {
        adjustToFrame();
        if(document.getElementById("signErrorDiv").style.display=="block"){
			setTimeout(function(){
            	document.getElementById("signErrorDiv").setAttribute("role","");
            	document.getElementById("signErrorDiv").setAttribute("role","alert");
			}, 500);
			dijit.setWaiState(dojo.byId("username"),"invalid","true");
			dijit.setWaiState(dojo.byId("password"),"invalid","true");
		}
    }
    </script>
    <script type="text/javascript">
        djConfig={
            locale:"<%=currentLocale%>"
        };
    </script>
    <%
    	final String _enablerContext = enablerContext;
    	enablerContext = realEnablerContext;
    %>
    <%@include file="include/dojo.jsp" %>
    <%
    	enablerContext = _enablerContext;
    %>
    
    <%@include file="include/builder.preload.jsp"%>
    
    <script type="text/javascript">
        dojo.require("dijit._base.sniff");
        dojo.require("dijit._base.wai");
        
        var context = "<%=enablerContext%>/";
        
        dojo.addOnLoad(function() {
			dojo.attr(dojo.doc.documentElement,"lang",dojo.locale);
	        if (dojo.isSafari >= 4 && dojo.isSafari < 5) {
				dojo.addClass(dojo.doc.documentElement,"dj_safari4");
			}
			
			// #19417 preload images in login page
			if(dojo.isIE){
                preloadImageUrls = preloadImageUrls.concat(IE_preloadImageUrls);
            }
            try{
                for(var i=0, l=preloadImageUrls.length; i<l; i++) {
                    var image = new Image();
                    image.src = context + preloadImageUrls[i];
					//console.log(image.src);
                    preloadImages.push(image);
                }
            }catch(e){}	
		});
		
		dojo.addOnUnload(function() {
			for(var i=0, l=preloadImages.length; i<l; i++) {
                delete preloadImages[i];
            }
            delete preloadImages;
		});
    </script>